# StateSelection

[![Build Status](https://github.com/JuliaComputing/StateSelection.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/JuliaComputing/StateSelection.jl/actions/workflows/CI.yml?query=branch%3Amain)

This package implements *structural* transformations suitable
of optimizing systems of (non-linear, ordinary differential, differential algebraic) equations for faster and more stable integration using a numerical solver. It is intended to serve as a common algorithmic core to a variety of downstream modeling systems, including [MTK](https://github.com/SciML/ModelingToolkit.jl), [DAECompiler](https://github.com/CedarEDA/DAECompiler.jl) and JuliaSimCompiler.

It is intended to be independent of the actual representation of the system of equations, instead operating on structural abstractions defined in this package. In particular, it computes only the transformations that *should* be the done to the system of equations, but the actual transformation of the system itself is deferred to the downstream user of this package.

## Transformations

This package implements *partial state selection* PSS. Unfortunately, the terminology is not entirely consistent in the literature, so before we proceed, we define PSS problem.

### The state selection problem

We will consider a *system* to be the dictum of a list of variables and equations together with

1. The structural incidence matrix of equations and variables
2. The numerical incidence matrix of the integer-linear constant-coefficient sub-system
3. For each equation-variable pair an indication of whether the downstream compiler is capable of solving the equation for that variable.
4. A graph of differential relations between the variables

Then, the *PSS problem* is to find

1. A (possibly empty) list of equations to differentiate
2. The assignment of each variable (or their derivatives if such derivative occurs in a differentiated equation) to one of
    1. A selected differential state
    2. An assignment to an equation (declaring the equation will be solved for this variable)
    3. An assignment to a linear-system of a list of equations
    4. An algebraic state

Such that
1. the dependency graph of variables (described further below) is acyclic
2. The provided solvability constraints are obeyed.

### Further remarks

There are several equivalent ways of thinking of this assignment. Two common ones in the literature are
1. an upper-triangular structural incidence matrix
2. a graph of dependencies between variables

To form the dependency graph of variables, let the vertices of the graph be the variables. For each variable assigned to an equation, add a directed edge from all other variables in the incidence-row of the said equation to the assigned variable.

Solutions to the PSS problem are not unique and the chosen solution materially affects the ease and stability of the resulting numerical integration. In general, a numerical integrator may need to switch the set of chosen states dynamically at runtime (known as dynamic state selection). Note that while this package has various hooks to control the selected states, and can compute the tearing sets, it does not by itself implement dynamic state selection.

# Detailed description of the transformation steps

### Structural Singularity Removal

This is a pre-pass that runs before pantelides. The primary objective of the pantelides algorithm is to ensure that the
jacobian of the fundamental ODE system is non-singular at runtime. However, because pantelides is a structural algorithm,
it can accidentally fail to fully reduce the index for systems which have full structural rank, but are numerically singular.
One common source of such systems are conservation laws commonly used in hierachical modeling tools.

However, fortunately, in such systems, the numerical singularity is static and apparent in the constant linear coefficients of the integer-linear subsystem (ILS) of the whole system.

As such, this pre-pass applies a change of basis to the ILS to make the numerical rank-deficiency structurally apparent, allowing pantelides to properly differentiate the resulting equations.

### Patenlides algorithm (DAE only)

The Pantelides algorithm is used for reduxing the differentiation index of the system to index 1 or 0, making it suitable for integration with a numerical integrator (such integrators are generally not capable of integrating higher-index DAE systems). This is accomplished by generating a list of equations to differentiate and adding these to the system.

### Dummy Derivatives (DAE only)

The pantelides algorithm produces systems that are over-determined in their differential relations (the sum of the number of differential relations and algebraic relations needs to match the number of variables). As such, some of these differential relations need to be removed in order to make the system solvable. However, the choice of which relations to remove can radically affect the numerical properties of the system and thus the ease and stability of the resulting integration.

### Tearing

Tearing computes a (directed) dependency graph of equations (or dually variables). If this graph is fully connected and has no cycles, all output variables are uniquely determined given all input variables, so the system will have no algebraic states. In general however, this dependency graph may have cycles (referred to as *algebraic loops*). Such cycles are broken numerically by choosing one or more variables in the cycle as algebraic states and (at runtime) wrapping a non-linear solver around these variables. Again,
the choice of algebraic states greatly affects the ease and stability of the resulting solve or integration.


## History

The code in this package can be traced back to
JuliaComputing/StructuralTransformations.jl, which provided a port of the structural transformation core from [Modia](https://github.com/ModiaSim/Modia.jl) to MTK's data structures. This package was subsequently integrated into MTK, with a number of intervening rewrites, simplifications and cleanups (both in code and understanding), before be-ing re-extracted to become this package.

using BipartiteGraphs: Label, BipartiteAdjacencyList

struct SSAUses{T}
    eqs::Vector{T} # equation uses
    vars::Vector{T} # variable uses
end
Base.eltype(info::SSAUses{T}) where {T} = T
Base.copy(uses::SSAUses) = SSAUses(copy(uses.eqs), copy(uses.vars))

ssa_uses(::SystemStructure) = nothing

struct SystemStructurePrintMatrix <:
       AbstractMatrix{Union{Label, BipartiteAdjacencyList}}
    bpg::BipartiteGraph
    highlight_graph::Union{Nothing, BipartiteGraph}
    var_to_diff::DiffGraph
    eq_to_diff::DiffGraph
    var_eq_matching::Union{Matching, Nothing}
    ssa_uses::Union{Nothing, SSAUses}
end

"""
Create a SystemStructurePrintMatrix to display the contents
of the provided SystemStructure.
"""
function SystemStructurePrintMatrix(s::SystemStructure)
    return SystemStructurePrintMatrix(complete(s.graph),
        s.solvable_graph === nothing ? nothing :
        complete(s.solvable_graph),
        complete(s.var_to_diff),
        complete(s.eq_to_diff),
        nothing,
        ssa_uses(s))
end
Base.size(bgpm::SystemStructurePrintMatrix) = (max(nsrcs(bgpm.bpg), ndsts(bgpm.bpg)) + 1, 9 + 2(bgpm.ssa_uses !== nothing))
function compute_diff_label(diff_graph, i, symbol)
    di = i - 1 <= length(diff_graph) ? diff_graph[i - 1] : nothing
    return di === nothing ? Label("") : Label(string(di, symbol))
end
function Base.getindex(bgpm::SystemStructurePrintMatrix, i::Integer, j::Integer)
    checkbounds(bgpm, i, j)
    if bgpm.ssa_uses === nothing
        # Skip SSAUse-related columns.
        j += (j ≥ 5) + (j ≥ 11)
    end
    if i <= 1
        return (Label.(("# eq", "∂ₜ", " ", " ", "%", "", "# v", "∂ₜ", " ", " ", "%")))[j]
    elseif j == 6
        colors = Base.text_colors
        return Label("|", :light_black)
    elseif j == 2
        return compute_diff_label(bgpm.eq_to_diff, i, '↑')
    elseif j == 3
        return compute_diff_label(invview(bgpm.eq_to_diff), i, '↓')
    elseif j == 8
        return compute_diff_label(bgpm.var_to_diff, i, '↑')
    elseif j == 9
        return compute_diff_label(invview(bgpm.var_to_diff), i, '↓')
    elseif j == 1
        return Label((i - 1 <= length(bgpm.eq_to_diff)) ? string(i - 1) : "")
    elseif j == 7
        return Label((i - 1 <= length(bgpm.var_to_diff)) ? string(i - 1) : "")
    elseif j == 4
        return BipartiteAdjacencyList(
            i - 1 <= nsrcs(bgpm.bpg) ?
            𝑠neighbors(bgpm.bpg, i - 1) : nothing,
            bgpm.highlight_graph !== nothing &&
            i - 1 <= nsrcs(bgpm.highlight_graph) ?
            Set(𝑠neighbors(bgpm.highlight_graph, i - 1)) :
            nothing,
            bgpm.var_eq_matching !== nothing &&
            (i - 1 <= length(invview(bgpm.var_eq_matching))) ?
            invview(bgpm.var_eq_matching)[i - 1] : unassigned)
    elseif j == 5
        return get(bgpm.ssa_uses.eqs, i - 1, Label(""))
    elseif j == 11
        return get(bgpm.ssa_uses.vars, i - 1, Label(""))
    elseif j == 10
        match = unassigned
        if bgpm.var_eq_matching !== nothing && i - 1 <= length(bgpm.var_eq_matching)
            match = bgpm.var_eq_matching[i - 1]
        end
        return BipartiteAdjacencyList(
            i - 1 <= ndsts(bgpm.bpg) ?
            𝑑neighbors(bgpm.bpg, i - 1) : nothing,
            bgpm.highlight_graph !== nothing &&
            i - 1 <= ndsts(bgpm.highlight_graph) ?
            Set(𝑑neighbors(bgpm.highlight_graph, i - 1)) :
            nothing, match)
    else
        @assert false
    end
end

struct IncidenceMarker <: Number
    active::Bool
end
Base.show(io::IO, inc::IncidenceMarker) = print(io, inc.active ? "x" : " ")

function Base.show(io::IO, mime::MIME"text/plain", s::SystemStructure)
    (; graph, solvable_graph, var_to_diff, eq_to_diff) = s
    if !get(io, :limit, true) || !get(io, :mtk_limit, true)
        print(io, "SystemStructure with ", length(s.graph.fadjlist), " equations and ",
            isa(s.graph.badjlist, Int) ? s.graph.badjlist : length(s.graph.badjlist),
            " variables\n")
        Base.print_matrix(io, SystemStructurePrintMatrix(s))
    else
        S = incidence_matrix(s.graph, IncidenceMarker(true))
        print(io, "Incidence matrix:")
        show(io, mime, S)
    end
end

struct MatchedSystemStructure
    structure::SystemStructure
    var_eq_matching::Matching
    ssa_uses::Union{Nothing, SSAUses}
end
MatchedSystemStructure(structure, var_eq_matching) = MatchedSystemStructure(structure, var_eq_matching, nothing)

ssa_uses(ms::MatchedSystemStructure) = ms.ssa_uses

"""
Create a SystemStructurePrintMatrix to display the contents
of the provided MatchedSystemStructure.
"""
function SystemStructurePrintMatrix(ms::MatchedSystemStructure)
    return SystemStructurePrintMatrix(complete(ms.structure.graph),
        complete(ms.structure.solvable_graph),
        complete(ms.structure.var_to_diff),
        complete(ms.structure.eq_to_diff),
        complete(ms.var_eq_matching, nsrcs(ms.structure.graph)),
        ms.ssa_uses)
end

function Base.copy(ms::MatchedSystemStructure)
    MatchedSystemStructure(copy(ms.structure), copy(ms.var_eq_matching), copy(ms.ssa_uses))
end

function Base.show(io::IO, mime::MIME"text/plain", ms::MatchedSystemStructure)
    s = ms.structure
    (; graph, solvable_graph, var_to_diff, eq_to_diff) = s
    print(io, "Matched SystemStructure with ", length(graph.fadjlist), " equations and ",
        isa(graph.badjlist, Int) ? graph.badjlist : length(graph.badjlist),
        " variables\n")
    Base.print_matrix(io, SystemStructurePrintMatrix(ms))
    printstyled(io, "\n\nLegend: ")
    printstyled(io, "Solvable")
    print(io, " | ")
    printstyled(io, "(Solvable + Matched)", color = :light_yellow)
    print(io, " | ")
    printstyled(io, "Unsolvable", color = :light_black)
    print(io, " | ")
    printstyled(io, "(Unsolvable + Matched)", color = :magenta)
    for T in Base.uniontypes(eltype(ms.var_eq_matching))
        T in (Int, Unassigned) && continue
        (symbol, label, color) = BipartiteGraphs.overview_label(T)
        print(io, " | ")
        printstyled(io, string(" ", symbol); color)
        printstyled(io, string(" ", label))
    end
    if ms.ssa_uses !== nothing
        T = eltype(ms.ssa_uses)
        (symbol, label, color) = BipartiteGraphs.overview_label(T)
        print(io, " | ")
        printstyled(io, string(" ", symbol); color)
        printstyled(io, string(" ", label))
    end
end

###
### Bipartite graph utilities
###
using BipartiteGraphs: 𝑠vertices, 𝑠neighbors

n_concrete_eqs(state::TransformationState) = n_concrete_eqs(state.structure)
n_concrete_eqs(structure::SystemStructure) = n_concrete_eqs(structure.graph)
function n_concrete_eqs(graph::BipartiteGraph)
    count(e -> !isempty(𝑠neighbors(graph, e)), 𝑠vertices(graph))
end

struct InvalidSystemException <: Exception
    msg::String
end
function Base.showerror(io::IO, e::InvalidSystemException)
    print(io, "InvalidSystemException: ", e.msg)
end

struct ExtraVariablesSystemException <: Exception
    msg::String
end
function Base.showerror(io::IO, e::ExtraVariablesSystemException)
    println(io, "ExtraVariablesSystemException: ", e.msg)
    print(io,
        "Note that the process of determining extra variables is a best-effort heuristic. " *
        "The true extra variables are dependent on the model and may not be in this list.")
end

struct ExtraEquationsSystemException <: Exception
    msg::String
end
function Base.showerror(io::IO, e::ExtraEquationsSystemException)
    println(io, "ExtraEquationsSystemException: ", e.msg)
    print(io,
        "Note that the process of determining extra equations is a best-effort heuristic. " *
        "The true extra equations are dependent on the model and may not be in this list.")
end

function error_reporting(state, bad_idxs, n_highest_vars, iseqs, orig_inputs)
    io = IOBuffer()
    neqs = n_concrete_eqs(state)
    if iseqs
        error_title = "More equations than variables, here are the potential extra equation(s):\n"
        out_arr = has_equations(state) ? equations(state)[bad_idxs] : bad_idxs
    else
        error_title = "More variables than equations, here are the potential extra variable(s):\n"
        out_arr = get_fullvars(state)[bad_idxs]
        unset_inputs = intersect(out_arr, orig_inputs)
        n_missing_eqs = n_highest_vars - neqs
        n_unset_inputs = length(unset_inputs)
        if n_unset_inputs > 0
            println(io, "In particular, the unset input(s) are:")
            Base.print_array(io, unset_inputs)
            println(io)
            println(io, "The rest of potentially unset variable(s) are:")
        end
    end

    Base.print_array(io, out_arr)
    msg = String(take!(io))
    if iseqs
        throw(ExtraEquationsSystemException("The system is unbalanced. There are " *
                                            "$n_highest_vars highest order derivative variables "
                                            * "and $neqs equations.\n"
                                            * error_title
                                            * msg))
    else
        throw(ExtraVariablesSystemException("The system is unbalanced. There are " *
                                            "$n_highest_vars highest order derivative variables "
                                            * "and $neqs equations.\n"
                                            * error_title
                                            * msg))
    end
end

###
### Structural check
###
"""
    $(TYPEDSIGNATURES)

Check if the `state` represents a singular system, and return the unmatched variables.
"""
function singular_check(state::TransformationState)
    (; graph, var_to_diff) = state.structure
    fullvars = get_fullvars(state)
    # This is defined to check if Pantelides algorithm terminates. For more
    # details, check the equation (15) of the original paper.
    extended_graph = (@set graph.fadjlist = Vector{Int}[graph.fadjlist;
                                                        map(collect, edges(var_to_diff))])
    extended_var_eq_matching = maximal_matching(extended_graph)

    nvars = ndsts(graph)
    unassigned_var = eltype(get_fullvars(state))[]
    for (vj, eq) in enumerate(extended_var_eq_matching)
        vj > nvars && break
        if eq === unassigned && !is_unused_var(state, vj)
            push!(unassigned_var, fullvars[vj])
        end
    end
    return unassigned_var

end

"""
    $TYPEDSIGNATURES

Check if the variable `var` is unsed by any equation in `state`. By default, checks
the incidence graph.
"""
function is_unused_var(state::TransformationState, var::Integer)
    return isempty(𝑑neighbors(state.structure.graph, var))
end

"""
    $(TYPEDSIGNATURES)

Check the consistency of `state`, given the inputs `orig_inputs`. If `nothrow == false`,
throws an error if the system is under-/over-determined or singular. In this case, if the
function returns it will return `true`. If `nothrow == true`, it will return `false`
instead of throwing an error. The singular case will print a warning.
"""
function check_consistency(state::TransformationState, orig_inputs; nothrow = false)
    neqs = n_concrete_eqs(state)
    (; graph, var_to_diff) = state.structure
    highest_vars = computed_highest_diff_variables(complete!(state.structure))
    n_highest_vars = 0
    for (v, h) in enumerate(highest_vars)
        h || continue
        is_unused_var(state, v) && continue
        n_highest_vars += 1
    end
    is_balanced = n_highest_vars == neqs

    if neqs > 0 && !is_balanced
        nothrow && return false
        varwhitelist = var_to_diff .== nothing
        var_eq_matching = maximal_matching(graph,
            dstfilter = v -> varwhitelist[v]) # not assigned
        # Just use `error_reporting` to do conditional
        iseqs = n_highest_vars < neqs
        if iseqs
            eq_var_matching = invview(complete(var_eq_matching, nsrcs(graph))) # extra equations
            bad_idxs = findall(isequal(unassigned), @view eq_var_matching[1:nsrcs(graph)])
        else
            bad_idxs = findall(isequal(unassigned), var_eq_matching)
        end
        error_reporting(state, bad_idxs, n_highest_vars, iseqs, orig_inputs)
    end

    unassigned_var = singular_check(state)

    if !isempty(unassigned_var) || !is_balanced
        nothrow && return false
        io = IOBuffer()
        Base.print_array(io, unassigned_var)
        unassigned_var_str = String(take!(io))
        errmsg = "The system is structurally singular! " *
                 "Here are the problematic variables: \n" *
                 unassigned_var_str
        throw(InvalidSystemException(errmsg))
    end

    return true
end

###
### BLT ordering
###

"""
    $TYPEDSIGNATURES

Find strongly connected components of the variables defined by `g`. `assign`
gives the undirected bipartite graph a direction. When `assign === nothing`, we
assume that the ``i``-th variable is assigned to the ``i``-th equation.
"""
function find_var_sccs(g::BipartiteGraph, assign = nothing)
    cmog = DiCMOBiGraph{true}(g,
        Matching(assign === nothing ? Base.OneTo(nsrcs(g)) : assign))
    sccs = Graphs.strongly_connected_components(cmog)
    cgraph = MatchedCondensationGraph(cmog, sccs)
    toporder = topological_sort(cgraph)
    sccs = sccs[toporder]
    foreach(sort!, sccs)
    return sccs
end

"""
    $TYPEDSIGNATURES

Find strongly connected components of algebraic variables in a system.
"""
function algebraic_variables_scc(structure::SystemStructure)
    graph = structure.graph
    # skip over differential equations
    algvars = BitSet(findall(v -> isalgvar(structure, v), 1:ndsts(graph)))
    algeqs = BitSet(findall(map(1:nsrcs(graph)) do eq
        all(v -> !isdervar(structure, v),
            𝑠neighbors(graph, eq))
    end))
    var_eq_matching = complete(
        maximal_matching(graph, e -> e in algeqs, v -> v in algvars), ndsts(graph))
    var_sccs = find_var_sccs(complete(graph), var_eq_matching)

    return var_eq_matching, var_sccs
end

"""
    $(TYPEDSIGNATURES)

Obtain the incidence matrix of the system sorted by the algebraic SCCs.
"""
function sorted_incidence_matrix(ts::TransformationState, val = true; only_algeqs = false,
        only_algvars = false)
    var_eq_matching, var_scc = algebraic_variables_scc(ts)
    s = ts.structure
    graph = ts.structure.graph
    varsmap = zeros(Int, ndsts(graph))
    eqsmap = zeros(Int, nsrcs(graph))
    varidx = 0
    eqidx = 0
    for vs in var_scc, v in vs
        eq = var_eq_matching[v]
        if eq !== unassigned
            eqsmap[eq] = (eqidx += 1)
            varsmap[v] = (varidx += 1)
        end
    end
    for i in diffvars_range(s)
        varsmap[i] = (varidx += 1)
    end
    for i in dervars_range(s)
        varsmap[i] = (varidx += 1)
    end
    for i in 1:nsrcs(graph)
        if eqsmap[i] == 0
            eqsmap[i] = (eqidx += 1)
        end
    end

    I = Int[]
    J = Int[]
    algeqs_set = algeqs(s)
    for eq in 𝑠vertices(graph)
        only_algeqs && (eq in algeqs_set || continue)
        for var in 𝑠neighbors(graph, eq)
            only_algvars && (isalgvar(s, var) || continue)
            i = eqsmap[eq]
            j = varsmap[var]
            (iszero(i) || iszero(j)) && continue
            push!(I, i)
            push!(J, j)
        end
    end
    SparseArrays.sparse(I, J, val, nsrcs(graph), ndsts(graph))
end

function add_row_coeffs!(
        row_col_i::Vector{Int}, row_val_i::Vector{T}, old_to_new_var::Vector{Int},
        aliases::Dict{Int, Int}, old_var::Int, coeff::T
    ) where {T}
    alias = get(aliases, old_var, 0)
    iszero(alias) && return
    push!(row_col_i, old_to_new_var[alias])
    push!(row_val_i, coeff)
    return nothing
end

function add_row_coeffs!(
        row_col_i::Vector{Int}, row_val_i::Vector{T}, old_to_new_var::Vector{Int},
        aliases::Dict{Int, SparseArrays.SparseVector{T, Int}}, old_var::Int, coeff::T
    ) where {T}
    alias = get(aliases, old_var, nothing)
    if alias isa SparseArrays.SparseVector{T, Int}
        I, V = SparseArrays.findnz(alias)
        append!(row_col_i, Iterators.map(Base.Fix1(getindex, old_to_new_var), I))
        append!(row_val_i, Iterators.map(Base.Fix1(*, coeff), V))
    end
    return nothing
end

"""
    $TYPEDSIGNATURES

Construct the new coefficient matrix with:

- Some equations removed, as indicated by `old_to_new_eq` which is obtained from
  `get_old_to_new_idxs`.
- Some variables removed and aliased to other variables, as indicated by `old_to_new_var`
  and `aliases`. `aliases` can be a `Dict{Int, Int}` indicating variables exactly aliased
  to others, or `Dict{Int, SparseVector{eltype(mm)}}` indicating variables aliased to linear
  combinations of others. Note that this is not recursive - if one variable
  depends on another aliased variable, it will lead to incorrect results.
"""
function get_new_mm(
        aliases::Dict{Int}, old_to_new_eq::Vector{Int}, old_to_new_var::Vector{Int},
        mm::CLIL.SparseMatrixCLIL
    )

    new_row_cols = eltype(mm.row_cols)[]
    new_row_vals = eltype(mm.row_vals)[]
    new_nzrows = Int[]
    indices = Int[]

    for (i, eq) in enumerate(mm.nzrows)
        old_to_new_eq[eq] > 0 || continue
        new_row_col_i = eltype(eltype(new_row_cols))[]
        new_row_val_i = eltype(eltype(new_row_vals))[]
        sizehint!(new_row_col_i, length(mm.row_cols[i]))
        sizehint!(new_row_val_i, length(mm.row_vals[i]))
        still_valid_eq = true
        for (var, coeff) in zip(mm.row_cols[i], mm.row_vals[i])
            if old_to_new_var[var] > 0
                push!(new_row_col_i, old_to_new_var[var])
                push!(new_row_val_i, coeff)
                continue
            end
            # This variable is removed, but not aliased to an integer coefficient linear
            # combination. As a result, this equation cannot be retained in `mm`.
            if !haskey(aliases, var)
                still_valid_eq = false
                break
            end

            add_row_coeffs!(new_row_col_i, new_row_val_i, old_to_new_var, aliases, var, coeff)
        end

        bad_idx = findfirst(iszero, new_row_col_i)
        if bad_idx isa Int
            throw(BadMMAliasError(bad_idx))
        end
        still_valid_eq || continue
        empty!(indices)
        append!(indices, LinearIndices(new_row_col_i))
        sortperm!(indices, new_row_col_i)
        final_row_cols = empty(new_row_col_i)
        final_row_vals = empty(new_row_val_i)
        push!(final_row_cols, new_row_col_i[indices[1]])
        push!(final_row_vals, new_row_val_i[indices[1]])
        for i in Iterators.drop(eachindex(indices), 1)
            col = new_row_col_i[indices[i]]
            # Compare against the last retained column, not the previous sorted
            # entry: a prior cancellation may have `pop!`ed the matching entry.
            if !isempty(final_row_cols) && col == final_row_cols[end]
                final_row_vals[end] += new_row_val_i[indices[i]]
                if iszero(final_row_vals[end])
                    pop!(final_row_cols)
                    pop!(final_row_vals)
                end
            else
                push!(final_row_cols, col)
                push!(final_row_vals, new_row_val_i[indices[i]])
            end
        end

        push!(new_row_cols, final_row_cols)
        push!(new_row_vals, final_row_vals)
        push!(new_nzrows, old_to_new_eq[eq])
    end

    # Drop explicit zeros (e.g. from an alias that cancelled to zero) so they
    # don't survive as phantom structural nonzeros.
    new_mm = typeof(mm)(count(!iszero, old_to_new_eq), count(!iszero, old_to_new_var), new_nzrows, new_row_cols, new_row_vals)
    return SparseArrays.dropzeros!(new_mm)
end

struct BadMMAliasError <: Exception
    eq::Int
end

function Base.showerror(io::IO, err::BadMMAliasError)
    return print(
        io, """
        When processing equation $(err.eq), the list of aliases resulted in a linear
        combination of a removed variable. No variable should be aliased to a removed
        variable.
        """
    )
end

using BipartiteGraphs: 𝑑neighbors, 𝑠neighbors, nsrcs, ndsts,
    construct_augmenting_path!, unassigned, DiCMOBiGraph

"""
    $TYPEDSIGNATURES

Computes which variables are the "highest-differentiated" for purposes of
pantelides. Ordinarily this is relatively straightforward. However, in our
case, there is one complicating condition:

    We allow variables in the structure graph that don't appear in the
    system at all. What we are interested in is the highest-differentiated
    variable that actually appears in the system.

This function takes care of these complications are returns a boolean array
for every variable, indicating whether it is considered "highest-differentiated".

`varfilter` is a filter function which takes index of a variable in `structure` and
determines whether it should be included in the list.
"""
function computed_highest_diff_variables(structure::SystemStructure, varfilter)
    (; graph, var_to_diff) = structure

    nvars = length(var_to_diff)
    varwhitelist = falses(nvars)
    for var in 1:nvars
        varfilter(var) || continue
        if var_to_diff[var] === nothing && !varwhitelist[var]
            # This variable is structurally highest-differentiated, but may not actually appear in the
            # system (complication 1 above). Ascend the differentiation graph to find the highest
            # differentiated variable that does appear in the system or the alias graph).
            while isempty(𝑑neighbors(graph, var))
                var′ = invview(var_to_diff)[var]
                var′ === nothing && break
                var = var′
            end
            varwhitelist[var] = true
        end
    end

    # Remove any variables from the varwhitelist for whom a higher-differentiated
    # var is already on the whitelist.
    for var in 1:nvars
        varwhitelist[var] || continue
        var′ = var
        while (var′ = var_to_diff[var′]) !== nothing
            if varwhitelist[var′]
                varwhitelist[var] = false
                break
            end
        end
    end

    return varwhitelist
end
computed_highest_diff_variables(structure::SystemStructure, diffvars::Union{BitVector, BitSet, Nothing}) =
    computed_highest_diff_variables(structure, var->_canchoose(diffvars, var))
computed_highest_diff_variables(structure::SystemStructure, ::Nothing=nothing) =
    computed_highest_diff_variables(structure, var->true)
_canchoose(diffvars::BitSet, var::Integer) = var in diffvars
_canchoose(diffvars::BitVector, var::Integer) = diffvars[var]
_canchoose(diffvars::Nothing, var::Integer) = true

"""
    pantelides!(state::TransformationState; kwargs...)

Perform Pantelides algorithm.
"""
function pantelides!(state::TransformationState; finalize = true, maxiters = 8000, eqfilter = eq->true, varfilter = var->true, kw...)
    (; graph, solvable_graph, var_to_diff, eq_to_diff) = state.structure
    neqs = nsrcs(graph)
    nvars = nv(var_to_diff)
    vcolor = falses(nvars)
    ecolor = falses(neqs)
    var_eq_matching = Matching(nvars)
    neqs′ = neqs
    nnonemptyeqs = count(
        eq -> !isempty(𝑠neighbors(graph, eq)) && eq_to_diff[eq] === nothing && eqfilter(eq),
        1:neqs′)

    varwhitelist = computed_highest_diff_variables(state.structure, varfilter)

    if nnonemptyeqs > count(varwhitelist)
        throw(InvalidSystemException("System is structurally singular"))
    end

    for k in 1:neqs′
        eq′ = k
        eqfilter(k) || continue
        eq_to_diff[eq′] === nothing || continue
        isempty(𝑠neighbors(graph, eq′)) && continue
        pathfound = false
        # In practice, `maxiters=8000` should never be reached, otherwise, the
        # index would be on the order of thousands.
        for iii in 1:maxiters
            # run matching on (dx, y) variables
            #
            # the derivatives and algebraic variables are zeros in the variable
            # association list
            resize!(vcolor, nvars)
            fill!(vcolor, false)
            resize!(ecolor, neqs)
            fill!(ecolor, false)
            pathfound = construct_augmenting_path!(var_eq_matching, graph, eq′,
                v -> varwhitelist[v], vcolor, ecolor)
            pathfound && break # terminating condition
            if is_only_discrete(state.structure)
                error("The discrete system has high structural index. This is not supported.")
            end
            for var in eachindex(vcolor)
                vcolor[var] || continue
                if var_to_diff[var] === nothing
                    # introduce a new variable
                    nvars += 1
                    var_diff = var_derivative!(state, var)
                    push!(var_eq_matching, unassigned)
                    push!(varwhitelist, false)
                    @assert length(var_eq_matching) == var_diff
                end
                varwhitelist[var] = false
                varwhitelist[var_to_diff[var]] = true
            end

            for eq in eachindex(ecolor)
                ecolor[eq] || continue
                # introduce a new equation
                neqs += 1
                eq_derivative!(state, eq; kw...)
            end

            for var in eachindex(vcolor)
                vcolor[var] || continue
                # the newly introduced `var`s and `eq`s have the inherits
                # assignment
                var_eq_matching[var_to_diff[var]] = eq_to_diff[var_eq_matching[var]]
            end
            eq′ = eq_to_diff[eq′]
        end # for _ in 1:maxiters
        pathfound ||
            error("maxiters=$maxiters reached! File a bug report if your system has a reasonable index (<100), and you are using the default `maxiters`. Try to increase the maxiters by `pantelides(sys::ODESystem; maxiters=1_000_000)` if your system has an incredibly high index and it is truly extremely large.")
    end # for k in 1:neqs′

    finalize && for var in 1:ndsts(graph)
        varwhitelist[var] && continue
        var_eq_matching[var] = unassigned
    end
    return var_eq_matching
end

# Algorithm based on:
# Carpanzano, E. (2000). Order Reduction of General Nonlinear DAE Systems by Automatic Tearing. Mathematical and Computer Modelling of Dynamical Systems, 6(2), 145–168. https://doi.org/10.1076/1387-3954(200006)6:2;1-M;FT145

"""
    $TYPEDEF

Tearing algorithm based on:

```
Carpanzano, E. (2000). Order Reduction of General Nonlinear DAE Systems by Automatic Tearing. Mathematical and Computer Modelling of Dynamical Systems, 6(2), 145–168. https://doi.org/10.1076/1387-3954(200006)6:2;1-M;FT145
```

# Fields

$TYPEDFIELDS
"""
@kwdef struct CarpanzanoTearing{F, F2, F3} <: TearingAlgorithm
    """
    Filter function to mark if a variable is a non-dummy derivative, part of a modification
    to the original algorithm. If multiple equations are explicitly solvable for exactly one
    variable in the SCC, prefer the one which is solvable for a non-dummy derivative.
    """
    isder::F = nothing
    """
    Filter function for variables to consider when tearing. Variables rejected by the
    filter do not participate in the maximal matching and subsequent SCC decomposition.
    """
    varfilter::F2 = (_ -> true)
    """
    Filter function for equations to consider when tearing. Equations rejected by the
    filter do not participate in the maximal matching and subsequent SCC decomposition.
    """
    eqfilter::F3 = (_ -> true)
    """
    The integer-linear subsystem matrix (see `get_mm`), or `nothing`. When provided,
    SCCs consisting entirely of integer-linear equations are matched exactly: a
    fraction-free Bareiss factorization of the SCC's rows over its own variables
    replaces the equations with their triangular reduced forms and matches each
    equation to its pivot — a numerically proven assignment. A rank-deficient
    factorization means the SCC is genuinely singular as scheduled and falls back
    to the structural heuristics.
    """
    mm::Union{Nothing, SparseMatrixCLIL{Int, Int}} = nothing
end

"""
    $TYPEDSIGNATURES

In `full_var_eq_matching`, for a fully determined system, we expect every valid variable
to be matched to a valid equation. `var_eq_matching` will have some  `unassigned`. Update
`full_var_eq_matching` to match `var_eq_matching`, and fill in the `unassigned` as best as
possible.
"""
function update_full_var_eq_matching!(
        graph, full_var_eq_matching, var_eq_matching, vars::Vector{Int},
        eqs::OrderedSet{Int}; varfilter
    )
    # In `full_var_eq_matching`, for a fully determined system, we expect every valid
    # variable to be matched to a valid equation. `var_eq_matching` will have some 
    # `unassigned`. Update `full_var_eq_matching` to match `var_eq_matching`, and
    # fill in the `unassigned` as best as possible.
    for var in vars
        if varfilter(var)
            eq = full_var_eq_matching[var] = var_eq_matching[var]
            eq isa Int && delete!(eqs, eq)
        end
    end

    for var in vars
        isempty(eqs) && break
        varfilter(var) || continue
        _eq = full_var_eq_matching[var]
        _eq isa Int && continue
        found = false
        for eq in eqs
            Graphs.has_edge(graph, BipartiteGraphs.BipartiteEdge(eq, var)) || continue
            found = true
            full_var_eq_matching[var] = eq
            delete!(eqs, eq)
            break
        end
        found && continue
        eq = full_var_eq_matching[var] = first(eqs)
        delete!(eqs, eq)
    end
end

"""
    $TYPEDSIGNATURES

Try to match the SCC given by `active_vars`/`active_eqs` exactly. Applicable when the
SCC is square and every equation is a row of the integer-linear subsystem `mm` (with
`mm_row_of` mapping equation index to `mm` row index, and each row in sync with the
structural graph). Runs a fraction-free Bareiss factorization of those rows with
pivoting restricted to `active_vars` (preferring variables satisfying `isder`):

- Full rank: the SCC is proven nonsingular. The equations are replaced — in `mm`, the
  structural graph and the solvable graph — by their reduced, triangular forms, and
  each is matched to its pivot variable. The triangular structure makes the
  solved-equation dependency graph acyclic (matching against the *original* row
  contents could produce cycles, which `reassemble` cannot schedule), and every pivot
  coefficient is proven nonzero, so downstream elimination can never manufacture an
  exactly singular system from these rows. The `(equation, columns, coefficients)`
  triples are appended to `rewrites` so the caller can update the symbolic equations
  to match.
- Rank deficient: the SCC's coefficient matrix over its own variables is exactly
  singular — the block cannot determine its variables no matter the matching. Warn
  and return `false` so the caller falls back to the structural heuristics.

Returns `true` iff the SCC was matched exactly.
"""
function exact_scc_matching!(
        structure::SystemStructure, mm::SparseMatrixCLIL{T, Ti}, mm_row_of::Dict{Int, Int},
        var_eq_matching::MatchingT, active_vars::AbstractSet{Int},
        active_eqs::AbstractSet{Int}, isder::F,
        rewrites::Vector{Tuple{Int, Vector{Int}, Vector{Int}}}
    ) where {T, Ti, F}
    n = length(active_eqs)
    (n >= 2 && n == length(active_vars)) || return false
    (; graph, solvable_graph) = structure

    # Every equation must be an integer-linear row whose cached coefficients are
    # in sync with the structural graph.
    rowids = Vector{Int}(undef, n)
    for (j, e) in enumerate(active_eqs)
        i = get(mm_row_of, e, nothing)
        i === nothing && return false
        cols = mm.row_cols[i]
        nbrs = 𝑠neighbors(graph, e)
        length(nbrs) == length(cols) || return false
        sort(nbrs) == cols || return false
        rowids[j] = i
    end

    nvars = ndsts(graph)
    active_mask = falses(nvars)
    tier1 = falses(nvars)
    for v in active_vars
        active_mask[v] = true
        isder !== nothing && isder(v) && (tier1[v] = true)
    end

    sub = SparseMatrixCLIL{T, Ti}(
        mm.nparentrows, mm.ncols,
        Ti[mm.nzrows[i] for i in rowids],
        Vector{Ti}[copy(mm.row_cols[i]) for i in rowids],
        Vector{T}[copy(mm.row_vals[i]) for i in rowids])
    ctx = RestrictedBareissContext(tier1, active_mask, nothing)
    update! = RestrictedContextUpdate(ctx, bareiss_update_virtual_colswap_mtk!)
    bareiss_ops = (noop_colswap, SyncedSwapRows(nothing), update!, bareiss_zero!)
    bareiss!(sub, bareiss_ops; find_pivot = ctx)
    rank = length(ctx.pivots)

    if rank < n
        @warn lazy"An SCC of $n integer-linear equations is exactly singular over its own \
        variables (rank $rank): the block cannot determine the variables it is scheduled \
        to solve. Falling back to structural tearing; expect a singular linear system \
        downstream. Equations: $(sort!(collect(active_eqs)))." maxlog = 10
        return false
    end

    haskey(ENV, "EXACT_SCC_DEBUG") &&
        println("exact SCC match: n=$n eqs=$(sort!(collect(active_eqs)))")
    for k in 1:n
        e = sub.nzrows[k]
        i = mm_row_of[e]
        mm.row_cols[i] = sub.row_cols[k]
        mm.row_vals[i] = sub.row_vals[k]
        set_neighbors!(graph, e, sub.row_cols[k])
        if solvable_graph isa BipartiteGraph{Int, Nothing}
            set_neighbors!(solvable_graph, e, sub.row_cols[k])
        end
        var_eq_matching[ctx.pivots[k]] = e
        push!(rewrites, (e, sub.row_cols[k], sub.row_vals[k]))
    end
    return true
end

function (alg::CarpanzanoTearing)(structure::SystemStructure)
    (; isder, varfilter, eqfilter, mm) = alg
    (; graph, solvable_graph) = structure

    var_eq_matching = maximal_matching(
        graph, Unassigned;
        srcfilter = eqfilter,
        dstfilter = varfilter
    )
    var_eq_matching = complete(
        var_eq_matching,
        max(
            length(var_eq_matching),
            maximum(x -> x isa Int ? x : 0, var_eq_matching, init = 0)
        )
    )

    full_var_eq_matching = copy(var_eq_matching)
    var_sccs = find_var_sccs(graph, var_eq_matching)

    # Exact matching of pure integer-linear SCCs is only implemented for
    # continuous systems.
    mm_row_of = if mm !== nothing && !is_only_discrete(structure)
        Dict{Int, Int}(e => i for (i, e) in enumerate(mm.nzrows))
    else
        nothing
    end
    rewrites = Tuple{Int, Vector{Int}, Vector{Int}}[]

    active_vars = OrderedSet{Int}()
    active_eqs = OrderedSet{Int}()
    remaining_eqs = OrderedSet{Int}()
    for vars in var_sccs
        empty!(active_vars)
        empty!(active_eqs)
        empty!(remaining_eqs)
        for var in vars
            # Identify variables and equations in this SCC
            if varfilter(var)
                push!(active_vars, var)
                # Don't need to check `eqfilter` here, it wouldn't be matched if it didn't
                # pass the filter.
                if var_eq_matching[var] isa Int
                    push!(active_eqs, var_eq_matching[var])
                    push!(remaining_eqs, var_eq_matching[var])
                end
            end
            # Tearing will now determine the matching
            var_eq_matching[var] = unassigned
        end
        exact = mm_row_of !== nothing && exact_scc_matching!(
            structure, mm, mm_row_of, var_eq_matching, active_vars, active_eqs,
            isder, rewrites)
        if !exact
            carpanzano_tear_scc!(alg, structure, var_eq_matching, active_vars, active_eqs)
        end
        update_full_var_eq_matching!(graph, full_var_eq_matching, var_eq_matching, vars, remaining_eqs; varfilter)
    end

    extra = (; linear_rewrite = rewrites)
    return TearingResult(var_eq_matching, full_var_eq_matching, var_sccs), extra
end

"""
    $TYPEDSIGNATURES

Among the equations in `active_eqs`, find an equation `ieq` which is incident on and solvable
for exactly one variable `ivar` in `active_vars`. The variable must also satisfy `condition`.
If such an equation is found, then `var_eq_matching[ivar]` is updated to `ieq`. Returns
`ieq`, or `0` if no such equation is found.

In the context of the paper, `structure.graph` is the associated bipartite graph and
`structure.solvable_graph` is the subgraph composed of **bold** edges.
"""
function find_single_solvable_eq!(
        structure::SystemStructure, var_eq_matching::MatchingT,
        active_vars::AbstractSet{Int}, active_eqs::AbstractSet{Int}, condition::F = _ -> true;
        nbors_buffer::Vector{Int} = Int[]
    ) where {F}
    (; graph, solvable_graph) = structure
    nbors = nbors_buffer
    for ieq in active_eqs
        empty!(nbors)
        append!(nbors, Iterators.filter(in(active_vars), 𝑠neighbors(graph, ieq)))
        length(nbors) == 1 || continue
        first_solvable_var = only(nbors)
        Graphs.has_edge(solvable_graph, BipartiteEdge(ieq, first_solvable_var)) || continue
        return var_eq_matching[first_solvable_var] = ieq
    end

    return 0
end

"""
    $TYPEDSIGNATURES

Tear an SCC composed of variables in `active_vars` and equations in `active_eqs` using
a modified version of Carpanzano's algorithm. `var_eq_matching` is expected to map
all of `active_vars` to `unassigned`, and will be modified to match solvable variables
(`assVars` in the paper) to the corresponding equations used to solve for them
(`assEqs` correspondingly). The function is allowed to mutate `active_vars` and
`active_eqs`.
"""
function carpanzano_tear_scc!(
        alg::CarpanzanoTearing, structure::SystemStructure, var_eq_matching::MatchingT,
        active_vars::AbstractSet{Int}, active_eqs::AbstractSet{Int}
    )
    # TODO: This is an implementation of algorithm A1 in the paper. Find an efficient
    # way to implement algorithm A2 and analyze the benefits.

    (; graph, solvable_graph) = structure
    # Variable priorities (when available) act as tie-breaks for the tear-variable
    # selection below: among otherwise-equivalent candidates, prefer marking the
    # variable with the HIGHEST priority as algebraic (torn), mirroring the
    # `state_priority` semantics of dummy-derivative state selection. With uniform
    # priorities the behavior is unchanged.
    varpriority = has_state_priorities(structure) ? get_state_priorities(structure) : nothing
    # Canonical (name-rank) tie-break after priorities: makes the tear-variable
    # selection deterministic under equation/declaration reordering.
    canonrank = has_canonical_ranks(structure) ? get_canonical_ranks(structure) : nothing
    # Sort key: prefer HIGHER priority, then SMALLER canonical rank.
    tearkey = v -> (varpriority === nothing ? 0 : -varpriority[v],
                    canonrank === nothing ? 0 : canonrank[v])
    # Find variables which cannot be solved for using any of the equations in this SCC,
    # and remove them from `active_vars`.
    filter!(Base.Fix1(any, in(active_eqs)) ∘ Base.Fix1(𝑑neighbors, solvable_graph), active_vars)

    enodes_with_min_incidence = Int[]
    non_solvable_incidence = Int[]
    while !isempty(active_vars)
        # Modification to the algorithm: prefer to find equations which can be solved
        # for exactly one variable in `active_vars` that satisfies `alg.isder`. Fall back
        # to the default behavior.
        if alg.isder !== nothing
            single_solvable_eq = find_single_solvable_eq!(
                structure, var_eq_matching, active_vars, active_eqs, alg.isder;
                nbors_buffer = enodes_with_min_incidence
            )
            if !iszero(single_solvable_eq)
                delete!(active_eqs, single_solvable_eq)
                delete!(active_vars, invview(var_eq_matching)[single_solvable_eq])
                continue
            end
        end
        single_solvable_eq = find_single_solvable_eq!(
            structure, var_eq_matching, active_vars, active_eqs;
            nbors_buffer = enodes_with_min_incidence
        )
        if !iszero(single_solvable_eq)
            delete!(active_eqs, single_solvable_eq)
            delete!(active_vars, invview(var_eq_matching)[single_solvable_eq])
            continue
        end

        # Implementation of the heuristic rules for selecting `v_r`, the variable
        # to be marked as algebraic, from section 4.3 in the paper.
        #
        # Heuristic 1: First identify equations with minimum number of incident edges.
        # `enodes_with_min_incidence` stores these equations, and `min_incidence_cnt`
        # is the corresponding number of incident edges.
        empty!(enodes_with_min_incidence)
        min_incidence_cnt = typemax(Int)
        for ieq in active_eqs
            cnt = count(in(active_vars), 𝑠neighbors(graph, ieq))
            cnt > min_incidence_cnt && continue
            if cnt == min_incidence_cnt
                push!(enodes_with_min_incidence, ieq)
                continue
            end

            min_incidence_cnt = cnt
            empty!(enodes_with_min_incidence)
            push!(enodes_with_min_incidence, ieq)
        end

        # Find a variable in `active_vars` which is present in one of these equations
        # and yet is not solvable in it. With priorities available, scan all
        # min-incidence equations and pick the highest-priority such variable
        # (strict comparison: first-found wins ties, matching the unprioritized
        # behavior when priorities are uniform).
        found_algvar = false
        alg_candidate = 0
        for ieq in enodes_with_min_incidence
            empty!(non_solvable_incidence)
            append!(non_solvable_incidence, 𝑠neighbors(graph, ieq))
            setdiff!(non_solvable_incidence, 𝑠neighbors(solvable_graph, ieq))
            intersect!(non_solvable_incidence, active_vars)

            isempty(non_solvable_incidence) && continue
            for ivar in non_solvable_incidence
                # We found such a variable, so remove it from `active_vars`.
                # We didn't update the matching, and the algorithm requires
                # all variables in `active_vars` be initially matched to `unassigned` so
                # this automatically makes it algebraic.
                if varpriority === nothing && canonrank === nothing
                    alg_candidate = ivar
                    found_algvar = true
                    break
                elseif alg_candidate == 0 || tearkey(ivar) < tearkey(alg_candidate)
                    alg_candidate = ivar
                end
            end

            found_algvar && break
        end

        if alg_candidate != 0
            delete!(active_vars, alg_candidate)
            found_algvar = true
        end

        found_algvar && continue

        # Heuristic 2:
        # Find all variables with maximum number of total incident edges, and of those
        # one which is solvable in the least number of equations. This can be done in one
        # pass without actually materializing a list.
        alg_var = 0
        max_incidence_cnt = typemin(Int)
        min_solvable_cnt = typemax(Int)
        best_key = (typemax(Int), typemax(Int))
        for ivar in active_vars
            cnt = count(in(active_eqs), 𝑑neighbors(graph, ivar))
            solvable_cnt = count(in(active_eqs), 𝑑neighbors(solvable_graph, ivar))
            key = tearkey(ivar)
            if iszero(alg_var) || cnt > max_incidence_cnt ||
               cnt == max_incidence_cnt && (solvable_cnt < min_solvable_cnt ||
                solvable_cnt == min_solvable_cnt && key < best_key)
                alg_var = ivar
                max_incidence_cnt = cnt
                min_solvable_cnt = solvable_cnt
                best_key = key
            end
        end

        delete!(active_vars, alg_var)
        # NOTE: Heuristic 2 will always identify a variable, so heuristic 3 is never
        # reachable. It might be worth checking if replacing heuristic 2 with 3 is
        # better, or if I overlooked something.
    end
    return
end

using BipartiteGraphs: Unassigned, maximal_matching

function partial_state_selection_graph!(state::TransformationState)
    var_eq_matching = complete(pantelides!(state))
    complete!(state.structure)
    partial_state_selection_graph!(state.structure, var_eq_matching)
end

function ascend_dg(xs, dg, level)
    while level > 0
        xs = Int[dg[x] for x in xs]
        level -= 1
    end
    return xs
end

function ascend_dg_all(xs, dg, level, maxlevel)
    r = Int[]
    while true
        if level <= 0
            append!(r, xs)
        end
        maxlevel <= 0 && break
        xs = Int[dg[x] for x in xs if dg[x] !== nothing]
        level -= 1
        maxlevel -= 1
    end
    return r
end

struct DiffData
    varlevel::Vector{Int}
    inv_varlevel::Vector{Int}
    inv_eqlevel::Vector{Int}
end

function pss_graph_modia!(structure::SystemStructure, maximal_top_matching, diff_data::Union{Nothing, DiffData}=nothing)
    (; eq_to_diff, var_to_diff, graph, solvable_graph) = structure

    # var_eq_matching is a maximal matching on the top-differentiated variables.
    # Find Strongly connected components. Note that after pantelides, we expect
    # a balanced system, so a maximal matching should be possible.
    var_sccs::Vector{Union{Vector{Int}, Int}} = find_var_sccs(graph, maximal_top_matching)
    var_eq_matching = Matching{Union{Unassigned, SelectedState}}(ndsts(graph))
    for vars in var_sccs
        # TODO: We should have a way to not have the scc code look at unassigned vars.
        if length(vars) == 1 && maximal_top_matching[vars[1]] === unassigned
            continue
        end

        # Now proceed level by level from lowest to highest and tear the graph.
        eqs = [maximal_top_matching[var]
               for var in vars if maximal_top_matching[var] !== unassigned]
        isempty(eqs) && continue
        maxeqlevel = diff_data === nothing ? 0 : maximum(map(x -> diff_data.inv_eqlevel[x], eqs))
        maxvarlevel = level = diff_data === nothing ? 0 : maximum(map(x -> diff_data.inv_varlevel[x], vars))
        old_level_vars = ()
        ict = IncrementalCycleTracker(
            DiCMOBiGraph{true}(graph,
                complete(Matching(ndsts(graph)), nsrcs(graph))),
            dir = :in)

        while level >= 0
            to_tear_eqs_toplevel = level == 0 ? eqs : filter(eq -> diff_data.inv_eqlevel[eq] >= level, eqs)
            to_tear_eqs = ascend_dg(to_tear_eqs_toplevel, invview(eq_to_diff), level)

            to_tear_vars_toplevel = level == 0 ? vars : filter(var -> diff_data.inv_varlevel[var] >= level, vars)
            to_tear_vars = ascend_dg(to_tear_vars_toplevel, invview(var_to_diff), level)

            assigned_eqs = Int[]

            if old_level_vars !== ()
                # Inherit constraints from previous level.
                # TODO: Is this actually a good idea or do we want full freedom
                # to tear differently on each level? Does it make a difference
                # whether we're using heuristic or optimal tearing?
                removed_eqs = Int[]
                removed_vars = Int[]
                for var in old_level_vars
                    old_assign = var_eq_matching[var]
                    if isa(old_assign, SelectedState)
                        push!(removed_vars, var)
                        continue
                    elseif !isa(old_assign, Int) ||
                           ict.graph.matching[var_to_diff[var]] !== unassigned
                        continue
                    end
                    # Make sure the ict knows about this edge, so it doesn't accidentally introduce
                    # a cycle.
                    assgned_eq = eq_to_diff[old_assign]
                    ok = try_assign_eq!(ict, var_to_diff[var], assgned_eq)
                    @assert ok
                    var_eq_matching[var_to_diff[var]] = assgned_eq
                    push!(removed_eqs, eq_to_diff[ict.graph.matching[var]])
                    push!(removed_vars, var_to_diff[var])
                    push!(removed_vars, var)
                end
                to_tear_eqs = setdiff(to_tear_eqs, removed_eqs)
                to_tear_vars = setdiff(to_tear_vars, removed_vars)
            end
            tearEquations!(ict, solvable_graph.fadjlist, to_tear_eqs, BitSet(to_tear_vars),
                nothing)

            for var in to_tear_vars
                @assert var_eq_matching[var] === unassigned
                assgned_eq = ict.graph.matching[var]
                var_eq_matching[var] = assgned_eq
                isa(assgned_eq, Int) && push!(assigned_eqs, assgned_eq)
            end

            if level != 0
                remaining_vars = collect(v
                for v in to_tear_vars
                if var_eq_matching[v] === unassigned)
                if !isempty(remaining_vars)
                    remaining_eqs = setdiff(to_tear_eqs, assigned_eqs)
                    nlsolve_matching = maximal_matching(graph,
                        srcfilter=Base.Fix2(in, remaining_eqs),
                        dstfilter=Base.Fix2(in, remaining_vars))
                    for var in remaining_vars
                        if nlsolve_matching[var] === unassigned &&
                           var_eq_matching[var] === unassigned
                            var_eq_matching[var] = SelectedState()
                        end
                    end
                end
            end

            old_level_vars = to_tear_vars
            level -= 1
        end
    end
    return complete(var_eq_matching, nsrcs(graph))
end

function partial_state_selection_graph!(structure::SystemStructure, var_eq_matching)
    (; eq_to_diff, var_to_diff, graph, solvable_graph) = structure
    eq_to_diff = complete(eq_to_diff)

    inv_eqlevel = map(1:nsrcs(graph)) do eq
        level = 0
        while invview(eq_to_diff)[eq] !== nothing
            eq = invview(eq_to_diff)[eq]
            level += 1
        end
        level
    end

    varlevel = map(1:ndsts(graph)) do var
        graph_level = level = 0
        while var_to_diff[var] !== nothing
            var = var_to_diff[var]
            level += 1
            if !isempty(𝑑neighbors(graph, var))
                graph_level = level
            end
        end
        graph_level
    end

    inv_varlevel = map(1:ndsts(graph)) do var
        level = 0
        while invview(var_to_diff)[var] !== nothing
            var = invview(var_to_diff)[var]
            level += 1
        end
        level
    end

    var_eq_matching = pss_graph_modia!(structure,
        complete(var_eq_matching), DiffData(varlevel, inv_varlevel,
        inv_eqlevel))

    var_eq_matching
end

function dummy_derivative_graph!(state::TransformationState, jac = nothing;
        state_priority = nothing, log = Val(false), kwargs...)
    state.structure.solvable_graph === nothing && find_solvables!(state; kwargs...)
    complete!(state.structure)
    var_eq_matching = complete(pantelides!(state; kwargs...))
    # NOTE: `get_mm` must be queried after `pantelides!`, which extends the
    # linear subsystem matrix with differentiated rows (`eq_derivative!`).
    dummy_derivative_graph!(
        state.structure, var_eq_matching, jac, state_priority, log; mm = get_mm(state))
end

struct DummyDerivativeSummary
    var_sccs::Vector{Vector{Int}}
    state_priority::Vector{Vector{Float64}}
end

"""
    $TYPEDSIGNATURES

Perform the dummy derivatives algorithm.

# Arguments

- `jac` is a function taking a list of equation and variable indices, and returning the
  jacobian for the same if it has all integer entries. Otherwise, the function should
  return `nothing`.
- `state_priority` is a function taking the index of a variable and returning its
  priority. Higher priority variables are more likely to be chosen as states.
"""
function dummy_derivative_graph!(
        structure::SystemStructure, var_eq_matching, jac = nothing,
        state_priority = nothing, ::Val{log} = Val(false);
        tearing_alg::TearingAlgorithm = DummyDerivativeTearing(),
        mm = nothing, kwargs...) where {log}
    (; eq_to_diff, var_to_diff, graph) = structure
    diff_to_eq = invview(eq_to_diff)
    diff_to_var = invview(var_to_diff)
    invgraph = invview(graph)
    cranks = has_canonical_ranks(structure) ? get_canonical_ranks(structure) : nothing
    extended_sp = let state_priority = state_priority, var_to_diff = var_to_diff,
        diff_to_var = diff_to_var

        var -> begin
            min_p = max_p = 0
            while var_to_diff[var] !== nothing
                var = var_to_diff[var]
            end
            while true
                p = state_priority(var)
                max_p = max(max_p, p)
                min_p = min(min_p, p)
                (var = diff_to_var[var]) === nothing && break
            end
            min_p < 0 ? min_p : max_p
        end
    end

    var_sccs = find_var_sccs(graph, var_eq_matching)
    var_perm = Int[]
    var_dummy_scc = Vector{Int}[]
    var_state_priority = Vector{Float64}[]
    eqcolor = falses(nsrcs(graph))
    dummy_derivatives = Int[]
    col_order = Int[]
    neqs = nsrcs(graph)
    nvars = ndsts(graph)
    eqs = Int[]
    vars = Int[]
    next_eq_idxs = Int[]
    next_var_idxs = Int[]
    new_eqs = Int[]
    new_vars = Int[]
    eqs_set = BitSet()
    for vars′ in var_sccs
        empty!(eqs)
        empty!(vars)
        for var in vars′
            eq = var_eq_matching[var]
            eq isa Int || continue
            diff_to_eq[eq] === nothing || push!(eqs, eq)
            if var_to_diff[var] !== nothing
                error("Invalid SCC")
            end
            (diff_to_var[var] !== nothing && is_present(structure, var)) && push!(vars, var)
        end
        isempty(eqs) && continue

        rank_matching = Matching(max(nvars, neqs))
        isfirst = true
        J = nothing
        if jac !== nothing
            J = jac(eqs, vars)
        end
        if J !== nothing
            is_all_small_int = true
            for i in eachindex(J)
                x = J[i]
                is_all_small_int = isinteger(x) && typemin(Int8) <= Int(x) <= typemax(Int8)
                is_all_small_int || break
            end
            J = is_all_small_int ? Int.(J) : nothing
        end
        while true
            nrows = length(eqs)
            iszero(nrows) && break

            if state_priority !== nothing && isfirst
                sp = extended_sp.(vars)
                resize!(var_perm, length(sp))
                if cranks === nothing
                    sortperm!(var_perm, sp)
                else
                    sortperm!(var_perm, collect(zip(sp, @view cranks[vars])))
                end
                permute!(vars, var_perm)
                permute!(sp, var_perm)
                # keep the Jacobian columns aligned with the permuted variable
                # order; `col_order` below indexes into `vars` (#102)
                J === nothing || (J = J[:, var_perm])
                push!(var_dummy_scc, copy(vars))
                push!(var_state_priority, sp)
            end
            # TODO: making the algorithm more robust
            # 1. If the Jacobian is a integer matrix, use Bareiss to check
            # linear independence. (done)
            #
            # 2. If the Jacobian is a single row, generate pivots. (Dynamic
            # state selection.)
            #
            # 3. If the Jacobian is a polynomial matrix, use Gröbner basis (?)
            if J !== nothing
                if !isfirst
                    J = J[next_eq_idxs, next_var_idxs]
                end
                N = bareiss.nullspace(J; col_order) # modifies col_order
                rank = length(col_order) - size(N, 2)
                for i in 1:rank
                    push!(dummy_derivatives, vars[col_order[i]])
                end
            else
                empty!(eqs_set)
                union!(eqs_set, eqs)
                rank = 0
                for var in vars
                    eqcolor .= false
                    # We need `invgraph` here because we are matching from
                    # variables to equations.
                    pathfound = construct_augmenting_path!(rank_matching, invgraph, var,
                        Base.Fix2(in, eqs_set), eqcolor)
                    pathfound || continue
                    push!(dummy_derivatives, var)
                    rank += 1
                    rank == nrows && break
                end
                fill!(rank_matching, unassigned)
            end
            if rank != nrows
                @warn "The DAE system is singular!"
            end

            # prepare the next iteration
            if J !== nothing
                empty!(next_eq_idxs)
                empty!(next_var_idxs)
            end
            empty!(new_eqs)
            empty!(new_vars)
            for (i, eq) in enumerate(eqs)
                ∫eq = diff_to_eq[eq]
                # descend by one diff level, but the next iteration of equations
                # must still be differentiated
                ∫eq === nothing && continue
                ∫∫eq = diff_to_eq[∫eq]
                ∫∫eq === nothing && continue
                if J !== nothing
                    push!(next_eq_idxs, i)
                end
                push!(new_eqs, ∫eq)
            end
            for (i, var) in enumerate(vars)
                ∫var = diff_to_var[var]
                ∫var === nothing && continue
                ∫∫var = diff_to_var[∫var]
                ∫∫var === nothing && continue
                if J !== nothing
                    push!(next_var_idxs, i)
                end
                push!(new_vars, ∫var)
            end
            eqs, new_eqs = new_eqs, eqs
            vars, new_vars = new_vars, vars
            isfirst = false
        end
    end

    if (n_diff_eqs = count(!isnothing, diff_to_eq)) !=
       (n_dummys = length(dummy_derivatives))
        @warn "The number of dummy derivatives ($n_dummys) does not match the number of differentiated equations ($n_diff_eqs)."
    end

    tearing_result, extra = if tearing_alg isa DummyDerivativeTearing
        tearing_alg(structure, BitSet(dummy_derivatives); mm)
    else
        tearing_alg(structure, BitSet(dummy_derivatives))
    end
    extra = (; extra..., ddsummary = DummyDerivativeSummary(var_dummy_scc, var_state_priority))
    return tearing_result, extra
end

function is_present(structure, v)::Bool
    (; var_to_diff, graph) = structure
    while true
        # if a higher derivative is present, then it's present
        isempty(𝑑neighbors(graph, v)) || return true
        v = var_to_diff[v]
        v === nothing && return false
    end
end

# Derivatives that are either in the dummy derivatives set or ended up not
# participating in the system at all are not considered differential
function is_some_diff(structure, dummy_derivatives, v)::Bool
    !(v in dummy_derivatives) && is_present(structure, v)
end

# We don't want tearing to give us `y_t ~ D(y)`, so we skip equations with
# actually differentiated variables.
function isdiffed((structure, dummy_derivatives), v)::Bool
    (; var_to_diff, graph) = structure
    diff_to_var = invview(var_to_diff)
    diff_to_var[v] !== nothing && is_some_diff(structure, dummy_derivatives, v)
end

function tearing_with_dummy_derivatives(structure, dummy_derivatives)
    (; var_to_diff) = structure
    # We can eliminate variables that are not selected (differential
    # variables). Selected unknowns are differentiated variables that are not
    # dummy derivatives.
    can_eliminate = falses(length(var_to_diff))
    for (v, dv) in enumerate(var_to_diff)
        dv = var_to_diff[v]
        if dv === nothing || !is_some_diff(structure, dummy_derivatives, dv)
            can_eliminate[v] = true
        end
    end
    var_eq_matching, full_var_eq_matching, var_sccs = tear_graph_modia(structure,
        Base.Fix1(isdiffed, (structure, dummy_derivatives)),
        Union{Unassigned, SelectedState};
        varfilter = Base.Fix1(getindex, can_eliminate))
    for v in 𝑑vertices(structure.graph)
        is_present(structure, v) || continue
        dv = var_to_diff[v]
        (dv === nothing || !is_some_diff(structure, dummy_derivatives, dv)) && continue
        var_eq_matching[v] = SelectedState()
    end
    return var_eq_matching, full_var_eq_matching, var_sccs, can_eliminate
end

struct DummyDerivativeTearing{T <: TearingAlgorithm} <: TearingAlgorithm end
DummyDerivativeTearing() = DummyDerivativeTearing{CarpanzanoTearing}()

function (::DummyDerivativeTearing{T})(
        structure::SystemStructure, dummy_derivatives::Union{BitSet, Tuple{}} = ();
        mm = nothing
    ) where {T}
    (; var_to_diff) = structure
    # We can eliminate variables that are not selected (differential
    # variables). Selected unknowns are differentiated variables that are not
    # dummy derivatives.
    can_eliminate = falses(length(var_to_diff))
    for (v, dv) in enumerate(var_to_diff)
        dv = var_to_diff[v]
        if dv === nothing || !is_some_diff(structure, dummy_derivatives, dv)
            can_eliminate[v] = true
        end
    end
    inner_tearing_alg = if :mm in fieldnames(T)
        T(;
            isder = Base.Fix1(isdiffed, (structure, dummy_derivatives)),
            varfilter = Base.Fix1(getindex, can_eliminate),
            mm
        )
    else
        T(;
            isder = Base.Fix1(isdiffed, (structure, dummy_derivatives)),
            varfilter = Base.Fix1(getindex, can_eliminate)
        )
    end
    tearing_result, inner_extra = inner_tearing_alg(structure)

    for v in 𝑑vertices(structure.graph)
        is_present(structure, v) || continue
        dv = var_to_diff[v]
        (dv === nothing || !is_some_diff(structure, dummy_derivatives, dv)) && continue
        tearing_result.var_eq_matching[v] = SelectedState()
    end

    return tearing_result, (; can_eliminate, inner_extra...)
end

using StateSelection
import StateSelection as SSel
using SparseArrays
using Test

include("bareiss.jl")
include("carpanzano_tearing.jl")

@testset "`get_new_mm`" begin
    mm = SSel.CLIL.SparseMatrixCLIL(
        [
            -1 0 2 0
            2 1 2 0
            0 0 1 2
        ]
    )
    # We're using the first equation to solve for the first variable,
    # and removing the last variable (assuming it's torn via some other
    # equation)
    old_to_new_eq = [0, 2, 3]
    old_to_new_var = [0, 1, 2, 0]
    aliases = Dict(1 => sparse([0, 0, 2, 0]))
    mm2 = SSel.get_new_mm(aliases, old_to_new_eq, old_to_new_var, mm)
    # Eq#3 can't be retained, because it depends on variable 4 which isn't an
    # integer coefficient linear combination
    @test mm2.nzrows == [2]
    @test mm2.row_cols == [[1, 2]]
    @test mm2.row_vals == [[1, 6]]
    @test mm2.ncols == 2
    aliases = Dict(1 => sparse([0, 0, 2, 1]))
    @test_throws SSel.BadMMAliasError SSel.get_new_mm(aliases, old_to_new_eq, old_to_new_var, mm)

    # Three entries collapse onto the same column, and the first two cancel to
    # zero. The remaining duplicate must survive as a fresh entry rather than
    # being folded into the (now popped) accumulator.
    # Row `[2 1 1]`: var1 retained, var2 -> -2*var1, var3 -> 3*var1.
    # Contributions to new col 1: 2 (direct) + 1*(-2) + 1*3 = 3.
    mm = SSel.CLIL.SparseMatrixCLIL([2 1 1])
    old_to_new_eq = [1]
    old_to_new_var = [1, 0, 0]
    aliases = Dict(2 => sparse([-2, 0, 0]), 3 => sparse([3, 0, 0]))
    mm2 = SSel.get_new_mm(aliases, old_to_new_eq, old_to_new_var, mm)
    @test mm2.nzrows == [1]
    @test mm2.row_cols == [[1]]
    @test mm2.row_vals == [[3]]
    @test mm2.ncols == 1

    # Same cancellation, but with a distinct retained column already present
    # before the cancelling group. The surviving duplicate must not leak into
    # the earlier column.
    # Row `[7 2 1 1]`: var1 -> col1, var2 -> col2, var3 -> -2*var2, var4 -> 5*var2.
    # col1 = 7, col2 = 2 + 1*(-2) + 1*5 = 5.
    mm = SSel.CLIL.SparseMatrixCLIL([7 2 1 1])
    old_to_new_eq = [1]
    old_to_new_var = [1, 2, 0, 0]
    aliases = Dict(3 => sparse([0, -2, 0, 0]), 4 => sparse([0, 5, 0, 0]))
    mm2 = SSel.get_new_mm(aliases, old_to_new_eq, old_to_new_var, mm)
    @test mm2.nzrows == [1]
    @test mm2.row_cols == [[1, 2]]
    @test mm2.row_vals == [[7, 5]]
    @test mm2.ncols == 2

    # An alias carrying an explicit stored zero (as `sparsevec` produces when
    # duplicate indices cancel) must not leak in as a phantom structural nonzero.
    # Row references var2 (removed, aliased to 0*var1) and var3 (retained); there
    # is no direct var1 term, so the only contribution to col 1 is the zero.
    mm = SSel.CLIL.SparseMatrixCLIL([0 1 1])
    old_to_new_eq = [1]
    old_to_new_var = [1, 0, 2]
    aliases = Dict(2 => sparsevec([1, 1], [2, -2], 3))
    mm2 = SSel.get_new_mm(aliases, old_to_new_eq, old_to_new_var, mm)
    @test mm2.row_cols == [[2]]
    @test mm2.row_vals == [[1]]
end

# NOTE: Checklist for adding new fields to `SystemStructure` or `TearingState`
# - Is it populated in the `TearingState` constructor?
# - Is it handled in the `copy` method?
# - Is it updated in `var_derivative!`? (if necessary)
# - Is it updated in `eq_derivative!`? (if necessary)
# - Is it updated in `rm_eqs_vars!`? (if necessary)
# - Is it updated in `scalarize_tearing_state_eqs!`? (if necessary)

"""
    $TYPEDEF

An struct implementing [`StateSelection.SystemStructure`](@ref) for
[`ModelingToolkitBase.System`](@ref).

# Fields

$TYPEDFIELDS
"""
Base.@kwdef mutable struct SystemStructure <: StateSelection.SystemStructure
    """Maps the index of variable x to the index of variable D(x)."""
    var_to_diff::StateSelection.DiffGraph
    """Maps the index of an algebraic equation to the index of the equation it is differentiated into."""
    eq_to_diff::StateSelection.DiffGraph
    """Graph that connects equations to variables that appear in them."""
    graph::BipartiteGraph{Int, Nothing}
    """Graph that connects equations to the variable they will be solved for during simplification."""
    solvable_graph::Union{BipartiteGraph{Int, Nothing}, Nothing}
    """Variable types (brownian, variable, parameter) in the system."""
    var_types::Vector{VariableType}
    """State priorities corresponding to each variable in `fullvars`"""
    state_priorities::Vector{Int}
    """
    Canonical rank of each variable in `fullvars`: the rank of the variable's name in
    lexicographic order. Used as a deterministic tie-break (after priorities) in tearing,
    so that results do not depend on equation/declaration order.
    """
    canonical_ranks::Vector{Int}
    """Whether the system is discrete."""
    only_discrete::Bool
end

function Base.copy(structure::SystemStructure)
    var_types = structure.var_types === nothing ? nothing : copy(structure.var_types)
    SystemStructure(copy(structure.var_to_diff), copy(structure.eq_to_diff),
        copy(structure.graph), copy(structure.solvable_graph),
        var_types, copy(structure.state_priorities), copy(structure.canonical_ranks),
        structure.only_discrete)
end

StateSelection.is_only_discrete(s::SystemStructure) = s.only_discrete

"""
    $TYPEDEF

An implementation of [`StateSelection.TransformationState`](@ref) for
[`ModelingToolkitBase.System`](@ref).

# Fields

$TYPEDFIELDS
"""
mutable struct TearingState <: StateSelection.TransformationState{System}
    """The system of equations."""
    sys::System
    """The set of variables of the system."""
    fullvars::Vector{SymbolicT}
    structure::SystemStructure
    extra_eqs::Vector{Equation}
    param_derivative_map::Dict{SymbolicT, SymbolicT}
    no_deriv_params::Set{SymbolicT}
    original_eqs::Vector{Equation}
    """
    Additional user-provided observed equations. The variables calculated here
    are not used in the rest of the system.
    """
    additional_observed::Vector{Equation}
    """
    Corresponding to `fullvars`, marks variables which may not be structurally present in
    any equation according to `structure.graph` but should not be considered as unused.
    This is typically used by variables on the RHS of equations in `additional_observed`,
    and is useful for ensuring the consistency check is valid. For example, a simplification
    pass prior to `StateSelection.check_consistency` may process the equations
    ```julia
    a ~ b
    b ~ c
    c ~ a
    ```
    Into `additional_observed = [a ~ b, c ~ b]`, and thus end up in a state where
    there are no equations and `fullvars = [b]`. The consistency check would consider `b` as
    unused and the system as fully determined, but in reality `b` should be considered
    as used and the system singular.
    """
    always_present::BitVector
    statemachines::Vector{System}
    """
    Source information for each equation in the `TearingState`. `Vector{Symbol}` for each
    equation representing the path of the subsystem to which it belongs. Empty entries
    indicate unknown source. If this field is empty, either the system has no equations
    or source information is unknown.
    """
    eqs_source::Vector{Vector{Symbol}}
    """
    A `SparseMatrixCLIL` identifying equations which are integer-coefficient linear
    combinations of variables.
    """
    mm::Union{Nothing, CLIL.SparseMatrixCLIL{Int, Int}}
    """
    A mapping from `D(x)` (not the `toterm` variant) to its derivative expression for
    analytically eliminated differential variables. No integrated or differentiated form
    of `x` should be present in the equations if its derivative specified here. Effectively,
    `x` along with all its integrated and differentiated forms must be eliminated as observed
    and put into `additional_observed`.
    """
    analytical_derivatives::Dict{SymbolicT, SymbolicT}
end

function Base.show(io::IO, state::TearingState)
    print(io, "TearingState of ", typeof(state.sys))
end

StateSelection.has_equations(::TearingState) = true
StateSelection.equations(ts::TearingState) = equations(ts)

struct EquationsView <: AbstractVector{Equation}
    ts::TearingState
end
MTKBase.equations(ts::TearingState) = EquationsView(ts)
Base.size(ev::EquationsView) = (length(equations(ev.ts.sys)) + length(ev.ts.extra_eqs),)
function Base.getindex(ev::EquationsView, i::Integer)
    eqs = equations(ev.ts.sys)
    if i > length(eqs)
        return ev.ts.extra_eqs[i - length(eqs)]
    end
    return eqs[i]
end
function Base.setindex!(ev::EquationsView, v::Equation, i::Integer)
    eqs = equations(ev.ts.sys)
    if i > length(eqs)
        ev.ts.extra_eqs[i - length(eqs)] = v
    else
        eqs[i] = v
    end
    return ev
end
function Base.push!(ev::EquationsView, eq)
    push!(ev.ts.extra_eqs, eq)
end

function TearingState(sys::System, source_info::Union{Nothing, MTKBase.EquationSourceInformation} = nothing; check::Bool = true, sort_eqs::Bool = true, defer_scalarization::Bool = false)
    # flatten system
    if source_info === nothing
        sys = MTKBase.flatten(sys)
    else
        @assert isempty(MTKBase.get_systems(sys)) """
        If `source_info` is provided to `TearingState`, the system must be flattened.
        """
    end
    sys = MTKBase.discrete_unknowns_to_parameters(sys)
    sys = MTKBase.discover_globalscoped(sys)
    MTKBase.check_no_parameter_equations(sys)
    iv = MTKBase.get_iv(sys)
    sources = Vector{Vector{Symbol}}()
    # flatten array equations
    if defer_scalarization
        # Don't scalarize eagerly — defer scalarization to after clock inference (via
        # scalarize_tearing_state_eqs!) so that only the relevant partition pays the cost.
        # The graph built here treats each (possibly array-valued) equation as a single node.
        if source_info !== nothing
            @assert length(equations(sys)) == length(source_info.eqs_source) """
            Mismatch between source information provided to `TearingState` and the structure \
            of the system.
            """
            sources = Vector{Vector{Symbol}}(source_info.eqs_source)
        end
        eqs = Vector{Equation}(equations(sys))
    else
        if source_info !== nothing
            @assert length(equations(sys)) == length(source_info.eqs_source) """
            Mismatch between source information provided to `TearingState` and the structure \
            of the system.
            """
            # Eager scalarization: expand each equation and replicate its source entry.
            for (eq, src) in zip(equations(sys), source_info.eqs_source)
                scal_eq = MTKBase.flatten_equation(eq)
                for _ in scal_eq
                    push!(sources, src)
                end
            end
        end
        eqs = MTKBase.flatten_equations(equations(sys))
        init_eqs = MTKBase.flatten_equations(initialization_equations(sys))
        @set! sys.initialization_eqs = init_eqs
    end
    any_array_eqs = false
    original_eqs = copy(eqs)
    neqs = length(eqs)
    param_derivative_map = Dict{SymbolicT, SymbolicT}()
    no_deriv_params = Set{SymbolicT}()
    fullvars = SymbolicT[]
    # * Scalarize unknowns
    dvs = Set{SymbolicT}()
    collect_vars_to_set!(dvs, unknowns(sys))
    ps = Set{SymbolicT}()
    collect_vars_to_set!(ps, parameters(sys; initial_parameters = true))
    # People sometimes pass completed systems to `mtkcompile`, which means the bound
    # parameters are not in `parameters(sys)` above. So add them here.
    if MTKBase.iscomplete(sys)
        collect_vars_to_set!(ps, collect(bound_parameters(sys)))
    end
    browns = Set{SymbolicT}()
    collect_vars_to_set!(browns, brownians(sys))
    var2idx = Dict{SymbolicT, Int}()
    var_types = VariableType[]

    addvar! = AddVar!(var2idx, dvs, fullvars, var_types)

    # build symbolic incidence
    symbolic_incidence = Vector{SymbolicT}[]
    varsbuf = OrderedSet{SymbolicT}()
    auxiliary_vars = OrderedSet{SymbolicT}()
    eqs_to_retain = trues(length(eqs))
    for (i, eq) in enumerate(eqs)
        any_array_eqs |= SU.is_array_shape(SU.shape(eq.lhs))
        eq, is_statemachine_equation = canonicalize_eq!(param_derivative_map, no_deriv_params, eqs_to_retain, ps, iv, i, eq)
        empty!(varsbuf)
        SU.search_variables!(varsbuf, eq; is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}())
        incidence = Set{SymbolicT}()
        isalgeq = true
        for v in varsbuf
            isequal(v, MTKBase.HOMOTOPY_LAMBDA) && continue
            # additionally track brownians in fullvars
            if v in browns
                addvar!(v, BROWNIAN)
                push!(incidence, v)
            end

            # TODO: Can we handle this without `isparameter`?
            if v in ps
                if iv isa SymbolicT && is_time_dependent_parameter(v, ps, iv) &&
                   !haskey(param_derivative_map, Differential(iv)(v)) && !(Differential(iv)(v) in no_deriv_params)
                    # Parameter derivatives default to zero - they stay constant
                    # between callbacks
                    param_derivative_map[Differential(iv)(v)] = Symbolics.COMMON_ZERO
                end
                continue
            end

            iv isa SymbolicT && isequal(v, iv) && continue
            iv isa SymbolicT && MTKBase.isdelay(v, iv) && continue

            if !in(v, dvs)
                arr, isidx = MTKBase.split_indexed_var(v)
                if isidx
                    # Handles cases list `D(x[1:2])`.
                    if SU.is_array_shape(SU.shape(v)) && SU.shape(v) isa SU.ShapeVecT
                        for idx in SU.stable_eachindex(v)
                            push!(auxiliary_vars, v[idx])
                        end
                        continue
                    end
                    # Handles cases like `x[i]` where `i` is a variable.
                    if any(!SU.isconst, Iterators.drop(arguments(v), 1)) && SU.shape(arr) isa SU.ShapeVecT
                        for idx in SU.stable_eachindex(arr)
                            push!(auxiliary_vars, arr[idx])
                        end
                        for arg in Iterators.drop(arguments(v), 1)
                            SU.search_variables!(
                                auxiliary_vars, arg; is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}()
                            )
                        end
                        continue
                    end
                end
                isvalid = @match v begin
                    BSImpl.Term(; f, args) => f isa Shift || isempty(args) || f isa SU.Operator && is_transparent_operator(f)::Bool
                    _ => false
                end
                v′ = v
                while !isvalid
                    @match v′ begin
                        BSImpl.Term(; f, args) => begin
                            if f isa Differential
                                v′ = args[1]
                            elseif f isa Shift
                                v′ = args[1]
                            else
                                break
                            end
                            if v′ in dvs
                                isvalid = true
                                break
                            end
                        end
                        _ => break
                    end
                end
                if !isvalid
                    throw(ArgumentError("$v is present in the system but $v′ is not an unknown."))
                end

                isempty(SU.shape(v)::SU.ShapeVecT) && addvar!(v, VARIABLE)
                @match v begin
                    BSImpl.Term(; f, args) && if f isa SU.Operator &&
                            !(f isa Differential)
                        end => begin
                            it = input_timedomain(f, args)::Vector{InputTimeDomainElT}
                            for (i, td) in enumerate(it)
                                v′ = args[i]
                                SU.isconst(v′) && continue
                                SU.search_variables!(auxiliary_vars, v′; is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}())
                            end
                    end
                    _ => nothing
                end
            end

            isalgeq &= !MTKBase.isdifferential(v)

            sh = SU.shape(v)::SU.ShapeVecT
            if isempty(sh)
                push!(incidence, v)
                addvar!(v, VARIABLE)
            elseif length(sh) == 1
                vv = collect(v)::Vector{SymbolicT}
                union!(incidence, vv)
                for vi in vv
                    addvar!(vi, VARIABLE)
                end
            elseif length(sh) == 2
                vv = collect(v)::Matrix{SymbolicT}
                union!(incidence, vv)
                for vi in vv
                    addvar!(vi, VARIABLE)
                end
            else
                vv = vec(collect(v)::Array{SymbolicT})::Vector{SymbolicT}
                union!(incidence, vv)
                for vi in vv
                    addvar!(vi, VARIABLE)
                end
            end
        end
        if isalgeq || is_statemachine_equation
            eqs[i] = eq
        end
        push!(symbolic_incidence, collect(incidence))
    end

    for v in auxiliary_vars
        if v in ps
            if iv isa SymbolicT && is_time_dependent_parameter(v, ps, iv) &&
                !haskey(param_derivative_map, Differential(iv)(v)) && !(Differential(iv)(v) in no_deriv_params)
                # Parameter derivatives default to zero - they stay constant
                # between callbacks
                param_derivative_map[Differential(iv)(v)] = Symbolics.COMMON_ZERO
            end
            continue
        end

        iv isa SymbolicT && isequal(v, iv) && continue
        iv isa SymbolicT && MTKBase.isdelay(v, iv) && continue

        if !in(v, dvs)
            isvalid = @match v begin
                BSImpl.Term(; f, args) => f isa Shift || isempty(args) || f isa SU.Operator && is_transparent_operator(f)::Bool
                _ => false
            end
            v′ = v
            while !isvalid
                @match v′ begin
                    BSImpl.Term(; f, args) => begin
                        if f isa Differential
                            v′ = args[1]
                        elseif f isa Shift
                            v′ = args[1]
                        else
                            break
                        end
                        if v′ in dvs
                            isvalid = true
                            break
                        end
                    end
                    _ => break
                end
            end
            if !isvalid
                throw(ArgumentError("$v is present in the system but $v′ is not an unknown."))
            end

            addvar!(v, VARIABLE)
            @match v begin
                BSImpl.Term(; f, args) && if f isa SU.Operator &&
                    !(f isa Differential)
                end => begin
                    it = input_timedomain(f, args)::Vector{InputTimeDomainElT}
                    for (i, td) in enumerate(it)
                        v′ = args[i]
                        SU.isconst(v′) && continue
                        SU.search_variables!(auxiliary_vars, v′; is_atomic = MTKBase.OperatorIsAtomic{SU.Operator}())
                    end
                end
                _ => nothing
            end
        end
        sh = SU.shape(v)::SU.ShapeVecT
        if isempty(sh)
            addvar!(v, VARIABLE)
        elseif length(sh) == 1
            vv = collect(v)::Vector{SymbolicT}
            for vi in vv
                addvar!(vi, VARIABLE)
            end
        elseif length(sh) == 2
            vv = collect(v)::Matrix{SymbolicT}
            for vi in vv
                addvar!(vi, VARIABLE)
            end
        else
            vv = vec(collect(v)::Array{SymbolicT})::Vector{SymbolicT}
            for vi in vv
                addvar!(vi, VARIABLE)
            end
        end
    end
    filter!(Base.Fix2(!==, MTKBase.COMMON_NOTHING) ∘ last, param_derivative_map)

    eqs = eqs[eqs_to_retain]
    original_eqs = original_eqs[eqs_to_retain]
    neqs = length(eqs)
    symbolic_incidence = symbolic_incidence[eqs_to_retain]
    if !isempty(sources)
        sources = sources[eqs_to_retain]
    end

    dervaridxs = OrderedSet{Int}()
    add_intermediate_derivatives!(fullvars, dervaridxs, addvar!)
    # Handle shifts - find lowest shift and add intermediates with derivative edges
    ### Handle discrete variables
    add_intermediate_shifts!(fullvars, dervaridxs, var2idx, addvar!, iv)
    # sort `fullvars` such that the mass matrix is as diagonal as possible.
    dervaridxs = collect(dervaridxs)
    fullvars, var_types = sort_fullvars(fullvars, dervaridxs, var_types, iv)
    var2idx = Dict{SymbolicT, Int}(fullvars .=> eachindex(fullvars))
    ndervars = length(dervaridxs)
    # invalidate `dervaridxs`, it is just `1:ndervars`
    dervaridxs = nothing

    # build `var_to_diff`
    var_to_diff = build_var_to_diff(fullvars, ndervars, var2idx, iv)

    state_priorities = build_state_priorities(sys, fullvars, var_to_diff)
    canonical_ranks = build_canonical_ranks(fullvars)

    if sort_eqs
        sortkeys = Vector{EquationSortKeyT}(undef, length(eqs))
        cache = Base.IdDict{SymbolicT, EquationSortKeyT}()
        for (i, eq) in enumerate(eqs)
            sortkeys[i] = get_equation_sort_key!(cache, eq, var2idx, canonical_ranks)
        end
        sortidxs = Base.sortperm(sortkeys)
        eqs = eqs[sortidxs]
        original_eqs = original_eqs[sortidxs]
        symbolic_incidence = symbolic_incidence[sortidxs]
        if !isempty(sources)
            sources = sources[sortidxs]
        end
    end

    # build incidence graph
    graph = defer_scalarization && any_array_eqs ?
        BipartiteGraph(neqs, length(fullvars), Val(false)) :
        build_incidence_graph(length(fullvars), symbolic_incidence, var2idx)

    # Identify unknowns that do not appear in any equations and are thus not present in
    # `fullvars`. The bindings and initial conditions for these variables should be removed.
    for v in fullvars
        delete!(dvs, v)
        arr, _ = MTKBase.split_indexed_var(v)
        delete!(dvs, arr)
    end
    new_binds = copy(parent(bindings(sys)))
    new_ics = copy(initial_conditions(sys))
    for var in dvs
        arr, isidx = MTKBase.split_indexed_var(var)
        if isidx
            if haskey(new_binds, arr)
                MTKBase.write_possibly_indexed_array!(
                    new_binds, var, MTKBase.COMMON_NOTHING, MTKBase.COMMON_NOTHING
                )
            else
                MTKBase.write_possibly_indexed_array!(
                    new_ics, var, MTKBase.COMMON_NOTHING, MTKBase.COMMON_NOTHING
                )
            end
        else
            delete!(new_binds, arr)
            delete!(new_ics, arr)
        end
    end

    @set! sys.eqs = eqs
    @set! sys.bindings = new_binds
    @set! sys.initial_conditions = new_ics

    eq_to_diff = StateSelection.DiffGraph(nsrcs(graph))

    structure = SystemStructure(complete(var_to_diff), complete(eq_to_diff),
                                complete(graph), nothing, var_types, state_priorities,
                                canonical_ranks, false)
    return TearingState(sys, fullvars, structure, Equation[], param_derivative_map,
                        no_deriv_params, original_eqs, Equation[], falses(length(fullvars)),
                        typeof(sys)[], sources, nothing, Dict{SymbolicT, SymbolicT}())
end

"""
Key used for sorting equations. Each element is a tuple of
(`canonical_rank` of variable, constant coefficient, exponent).
"""
const EquationSortKeyT = Vector{Tuple{Int, Float64, Float64}}

function get_equation_sort_key!(
        cache::Base.IdDict{SymbolicT, EquationSortKeyT}, eq::Equation,
        var2idx::Dict{SymbolicT, Int}, canonical_ranks::Vector{Int}
    )
    return get_expression_sort_key!(cache, eq.rhs, var2idx, canonical_ranks)
end

function get_expression_sort_key!(
        cache::Base.IdDict{SymbolicT, EquationSortKeyT}, expr::SymbolicT,
        var2idx::Dict{SymbolicT, Int}, canonical_ranks::Vector{Int}
    )
    val = get(cache, expr, nothing)
    val === nothing || return val
    val = __get_expression_sort_key!(cache, expr, var2idx, canonical_ranks)
    cache[expr] = val
    return val
end

function __get_expression_sort_key!(
        cache::Base.IdDict{SymbolicT, EquationSortKeyT}, expr::SymbolicT,
        var2idx::Dict{SymbolicT, Int}, canonical_ranks::Vector{Int}
    )
    @match expr begin
        # Use `0` as the rank for constants
        BSImpl.Const(; val)  => if val isa Real
            return [(0, convert(Float64, val), 1.0)]
        else
            return eltype(EquationSortKeyT)[]
        end
        BSImpl.Sym(;) => begin
            idx = get(var2idx, expr, nothing)
            idx === nothing && return eltype(EquationSortKeyT)[]
            return [(canonical_ranks[idx], 1.0, 1.0)]
        end
        BSImpl.AddMul(; coeff, dict, variant) => begin
            result = eltype(EquationSortKeyT)[]
            ks = collect(keys(dict))
            sort!(ks; lt = SU.:(<ₑ))
            if variant == SU.AddMulVariant.ADD
                for k in ks
                    arg_k = get_expression_sort_key!(cache, k, var2idx, canonical_ranks)
                    v = dict[k]
                    if !(v isa Real)
                        append!(result, arg_k)
                        continue
                    end
                    v = convert(Float64, v)
                    for t in arg_k
                        push!(result, (t[1], t[2] * v, t[3]))
                    end
                    length(result) > 100 && break
                end
            else
                if coeff isa Real
                    cf = convert(Float64, coeff)
                else
                    cf = 1.0
                end
                for k in ks
                    arg_k = get_expression_sort_key!(cache, k, var2idx, canonical_ranks)
                    v = dict[k]
                    if !(v isa Real)
                        append!(result, arg_k)
                        continue
                    end
                    v = convert(Float64, v)
                    for t in arg_k
                        push!(result, (t[1], abs(t[2]) ^ v * cf, t[3] + v))
                    end
                    length(result) > 100 && break
                end
            end
            return result
        end
        _ => begin
            idx = get(var2idx, expr, nothing)
            idx === nothing || return [(canonical_ranks[idx], 1.0, 1.0)]
            f = operation(expr)
            args = arguments(expr)
            if f === (^)
                base_key = get_expression_sort_key!(cache, args[1], var2idx, canonical_ranks)
                @match args[2] begin
                    BSImpl.Const(; val) => if val isa Real
                        v = convert(Float64, val)
                        return map(k -> (k[1], abs(k[2]) ^ v, k[3] + v), base_key)
                    else
                        length(base_key) > 100 && return base_key
                        return vcat(base_key, get_expression_sort_key!(cache, args[2], var2idx, canonical_ranks))
                    end
                    _ => begin
                        length(base_key) > 100 && return base_key
                        return vcat(base_key, get_expression_sort_key!(cache, args[2], var2idx, canonical_ranks))
                    end
                end
                return base_key
            end
            result = eltype(EquationSortKeyT)[]
            for arg in args
                append!(result, get_expression_sort_key!(cache, arg, var2idx, canonical_ranks))
                length(result) > 100 && break
            end
            return result
        end
    end
end
"""
    $TYPEDSIGNATURES

Total, allocation-light "canonical name" for any expression that may appear in
`fullvars`: the name for named variables (`Sym` / call-variable / `getindex`),
the operation's name for operator/function applications, and a fixed sentinel
symbol for the remaining structural variants. Key collisions are acceptable —
they only mean the canonical tie-break falls back to the original order among
the colliding entries.
"""
function canonical_name(x::SymbolicT)
    @match x begin
        BSImpl.Sym(; name) => name
        BSImpl.Term(; f, args) && if f === getindex end => canonical_name(args[1])
        BSImpl.Term(; f) => canonical_opname(f)
        BSImpl.AddMul(; variant) => variant === SU.AddMulVariant.ADD ? :+ : :*
        BSImpl.Div(;) => :/
        BSImpl.ArrayOp(;) => Symbol("#arrayop")
        BSImpl.Const(;) => Symbol("#const")
        _ => Symbol("#expr")
    end
end
function canonical_opname(@nospecialize(f))
    f isa SymbolicT && return canonical_name(f)
    f isa Function && return nameof(f)::Symbol
    return nameof(typeof(f))::Symbol
end

"""
    $TYPEDSIGNATURES

Structured canonical sort key for a `fullvars` entry: a tuple
`(name, indices, opsig)` where `name` is the [`canonical_name`](@ref) of the
underlying (array) variable, `indices` are the integer indices when `v` is a
scalarized array element (empty otherwise) and `opsig` encodes the operator
chain wrapping the variable (`Differential` → `1`; `Shift` → `2` followed by
its step count; any other single-argument operator → `3`). Comparing these
tuples orders variables deterministically regardless of equation/declaration
order, without stringifying symbolic expressions. Total: compound expressions
(e.g. multi-argument clock operators over non-variable arguments) key off
their operation name.
"""
function canonical_sort_key(v::SymbolicT)
    # `opsig`/`idxs` are built as `Vector{Int}` (not growing tuples) so the key
    # type is concrete and inferrable after the loop. Vectors compare
    # lexicographically, so the tuple ordering is unchanged.
    opsig = Int[]
    x = v
    while true
        stripped = @match x begin
            BSImpl.Term(; f, args) && if f isa Differential end => begin
                push!(opsig, 1)
                args[1]
            end
            BSImpl.Term(; f, args) && if f isa MTKBase.Shift end => begin
                push!(opsig, 2, Int(f.steps))
                args[1]
            end
            BSImpl.Term(; f, args) && if f isa SU.Operator && length(args) == 1 end => begin
                push!(opsig, 3)
                args[1]
            end
            _ => nothing
        end
        stripped === nothing && break
        x = stripped
    end
    idxs = Int[]
    @match x begin
        BSImpl.Term(; f, args) && if f === getindex end => begin
            for i in Iterators.drop(args, 1)
                ival = SU.isconst(i) ? manual_dispatch_is_small_int(unwrap_const(i))::Int : 0
                push!(idxs, ival)
            end
            x = args[1]
        end
        _ => nothing
    end
    return (opsig, canonical_name(x), idxs)
end

"""
    $TYPEDSIGNATURES

Rank of each variable in `fullvars` under the [`canonical_sort_key`](@ref) order.
Used as a deterministic tie-break (after priorities) in tearing. Ranks are multiplied
by a constant factor to enable inserting new variables in between.
"""
function build_canonical_ranks(fullvars::Vector{SymbolicT})
    return invperm(sortperm(map(canonical_sort_key, fullvars))) .* 100
end

"""
    $(TYPEDSIGNATURES)

Scalarize the equations in `ts` in-place and rebuild the bipartite graph. This is called
after clock inference so that only the continuous-time partition pays the scalarization
cost. Deferral of scalarization is controlled by the `defer_scalarization` keyword to the
`TearingState` constructor (independent of whether `source_info` is provided). This is a
no-op if there are no array-shaped equations (in particular, if `defer_scalarization` was
`false` at construction time, the equations are already scalar and every `flatten_equation`
call below returns its argument unchanged).

Assumes `ts.extra_eqs` is empty, i.e. this is called before any tearing/elimination pass has
added extra equations to `ts` — `ts.original_eqs` and `ts.eqs_source` only track the
equations originally present in `ts.sys`, not `ts.extra_eqs`.
"""
function scalarize_tearing_state_eqs!(ts::TearingState)
    arr_eqs = equations(ts.sys)
    # Early exit
    has_arr_eqs = any(eq -> SU.is_array_shape(SU.shape(eq.lhs)), arr_eqs)
    has_arr_eqs || iszero(Graphs.ne(ts.structure.graph)) || return ts

    arr_orig_eqs = ts.original_eqs
    eqs_source = ts.eqs_source

    new_eqs = Equation[]
    sizehint!(new_eqs, length(arr_eqs))
    new_orig = Equation[]
    sizehint!(new_orig, length(arr_orig_eqs))
    new_sources = Vector{Vector{Symbol}}()
    sizehint!(new_sources, length(eqs_source))

    for i in eachindex(arr_eqs)
        scalar_eqs = MTKBase.flatten_equation(arr_eqs[i])
        scalar_orig_eqs = MTKBase.flatten_equation(arr_orig_eqs[i])
        append!(new_eqs, scalar_eqs)
        append!(new_orig, scalar_orig_eqs)
        if !isempty(eqs_source)
            for _ in scalar_orig_eqs
                push!(new_sources, eqs_source[i])
            end
        end
    end

    # We sorted the unscalarized equations, so no need to redo sorting here

    # Rebuild the bipartite incidence graph from the scalar equations. `fullvars` is already
    # scalar (the constructor scalarizes variables even when equations are deferred).
    fullvars = ts.fullvars
    var2idx = Dict{SymbolicT, Int}(Iterators.map(reverse, enumerate(fullvars)))
    all_vars_set = Set{SymbolicT}(fullvars)
    for v in fullvars
        arr, isidx = MTKBase.split_indexed_var(v)
        isidx || continue
        push!(all_vars_set, arr)
    end
    varsbuf = Set{SymbolicT}()
    symbolic_incidence = Vector{Vector{SymbolicT}}()
    sizehint!(symbolic_incidence, length(new_eqs))
    for eq in new_eqs
        empty!(varsbuf)
        Symbolics.get_variables!(varsbuf, eq, all_vars_set)
        incidence = SymbolicT[]
        sizehint!(incidence, length(varsbuf))
        for v in varsbuf
            sh = SU.shape(v)::SU.ShapeVecT
            if isempty(sh)
                push!(incidence, v)
                continue
            end
            for i in SU.stable_eachindex(v)
                vi = v[i]
                push!(incidence, vi)
            end
        end
        push!(symbolic_incidence, incidence)
    end

    graph = build_incidence_graph(length(fullvars), symbolic_incidence, var2idx)

    sys = ts.sys
    init_eqs = MTKBase.flatten_equations(initialization_equations(sys))
    @set! sys.initialization_eqs = init_eqs
    @set! sys.eqs = new_eqs
    ts.sys = sys
    ts.original_eqs = new_orig
    ts.eqs_source = new_sources

    structure = ts.structure
    @set! structure.graph = complete(graph)
    @set! structure.eq_to_diff = StateSelection.DiffGraph(nsrcs(structure.graph))
    ts.structure = structure

    return ts
end

function build_state_priorities(sys::System, fullvars::Vector{SymbolicT}, var_to_diff::StateSelection.DiffGraph)
    # Cache the state priorities
    sps = state_priorities(sys)
    var_priorities = Int[]
    sizehint!(var_priorities, length(fullvars))
    for v in fullvars
        # Component-granular lookup: a priority on the scalarized variable
        # itself (e.g. `v_0[1] => 5`) takes precedence over a priority on its
        # parent array variable. This allows distinguishing array components,
        # which is impossible with the parent-array-only lookup.
        p = get(sps, v, nothing)
        if p === nothing
            arr, _ = MTKBase.split_indexed_var(v)
            p = get(sps, arr, 0)
        end
        push!(var_priorities, round(Int, p))
    end

    # Propagate priorities up the `var_to_diff` graph. Each variable's final priority is
    # the maximum of priorities of any of its derivatives
    diff_to_var = invview(var_to_diff)
    for i in eachindex(fullvars)
        # Find a variable that is the lowest order derivative
        diff_to_var[i] === nothing || continue
        p = var_priorities[i]
        var::Int = i
        # Iterate through the higher order derivatives and update their priorities
        while true
            p = var_priorities[var] = max(p, var_priorities[var])
            tmp = var_to_diff[var]
            tmp === nothing && break
            var = tmp
        end
    end

    return var_priorities
end

function sort_fullvars(fullvars::Vector{SymbolicT}, dervaridxs::Vector{Int}, var_types::Vector{VariableType}, @nospecialize(iv::Union{SymbolicT, Nothing}))
    if iv === nothing
        return fullvars, var_types
    end
    iv = iv::SymbolicT
    # Canonicalize the within-group order by `canonical_sort_key`
    ckcache = Dict{SymbolicT, Any}() # TODO: Fix Any type
    ckey(v) = get!(() -> canonical_sort_key(v), ckcache, v)
    dervaridxs = sort(dervaridxs; by = i -> ckey(fullvars[i]))
    sorted_fullvars = OrderedSet{SymbolicT}(fullvars[dervaridxs])
    var_to_old_var = Dict{SymbolicT, SymbolicT}(zip(fullvars, fullvars))
    for dervaridx in dervaridxs
        dervar = fullvars[dervaridx]
        diffvar = var_to_old_var[lower_order_var(dervar, iv)]
        if !(diffvar in sorted_fullvars)
            push!(sorted_fullvars, diffvar)
        end
    end
    for v in sort(fullvars; by = ckey)
        if !(v in sorted_fullvars)
            push!(sorted_fullvars, v)
        end
    end
    new_fullvars = collect(sorted_fullvars)
    sortperm = indexin(new_fullvars, fullvars)
    fullvars = new_fullvars
    var_types = var_types[sortperm]
    return fullvars, var_types
end

function build_var_to_diff(fullvars::Vector{SymbolicT}, ndervars::Int, var2idx::Dict{SymbolicT, Int}, @nospecialize(iv::Union{SymbolicT, Nothing}))
    nvars = length(fullvars)
    var_to_diff = StateSelection.DiffGraph(nvars, true)
    if iv === nothing
        return var_to_diff
    end
    iv = iv::SymbolicT
    for dervaridx in 1:ndervars
        dervar = fullvars[dervaridx]
        diffvar = lower_order_var(dervar, iv)
        diffvaridx = var2idx[diffvar]
        var_to_diff[diffvaridx] = dervaridx
    end
    return var_to_diff
end

function build_incidence_graph(nvars::Int, symbolic_incidence::Vector{Vector{SymbolicT}}, var2idx::Dict{SymbolicT, Int})
    neqs = length(symbolic_incidence)
    graph = BipartiteGraph(neqs, nvars, Val(false))
    for (ie, vars) in enumerate(symbolic_incidence), v in vars
        jv = var2idx[v]
        add_edge!(graph, ie, jv)
    end

    return graph
end

function collect_vars_to_set!(buffer::Set{SymbolicT}, vars::Vector{SymbolicT})
    for x in vars
        push!(buffer, x)
        @match x begin
            BSImpl.Term(; f, args) && if f === getindex end => push!(buffer, args[1])
            _ => nothing
        end
        sh = SU.shape(x)
        sh isa SU.Unknown && continue
        sh = sh::SU.ShapeVecT
        isempty(sh) && continue
        idxs = SU.stable_eachindex(x)
        for i in idxs
            push!(buffer, x[i])
        end
    end
end

function canonicalize_eq!(param_derivative_map::Dict{SymbolicT, SymbolicT}, no_deriv_params::Set{SymbolicT}, eqs_to_retain::BitVector, ps::Set{SymbolicT}, @nospecialize(iv::Union{Nothing, SymbolicT}), i::Int, eq::Equation)
    is_statemachine_equation = false
    lhs = eq.lhs
    rhs = eq.rhs
    @match lhs begin
        BSImpl.Term(; f, args) && if f isa Differential && iv isa SymbolicT && isequal(f.x, iv) &&
                                     is_time_dependent_parameter(args[1], ps, iv)
                                 end => begin
            # parameter derivatives are opted out by specifying `D(p) ~ missing`, but
            # we want to store `nothing` in the map because that means `substitute`
            # will ignore the rule. We will this identify the presence of `eq′.lhs` in
            # the differentiated expression and error.
            if eq.rhs !== MTKBase.COMMON_MISSING
                param_derivative_map[lhs] = rhs
                eq = Symbolics.COMMON_ZERO ~ rhs
            else
                # change the equation if the RHS is `missing` so the rest of this loop works
                eq = Symbolics.COMMON_ZERO ~ Symbolics.COMMON_ZERO
                push!(no_deriv_params, lhs)
                delete!(param_derivative_map, lhs)
            end
            eqs_to_retain[i] = false
        end
        BSImpl.Const(; val) && if val isa StateMachineOperator end => begin
            is_statemachine_equation = true
        end
        BSImpl.Const(;) && if SU._iszero(lhs) end => nothing
        _ => begin
            # Skip canonicalization for array-shaped lhs — creating `0 ~ rhs - lhs`
            # would fail with a size mismatch. Array equations are scalarized later by
            # scalarize_tearing_state_eqs!, which applies canonical form to each scalar piece.
            if isempty(SU.shape(lhs)::SU.ShapeVecT)
                eq = Symbolics.COMMON_ZERO ~ (rhs - lhs)
            end
        end
    end
    return eq, is_statemachine_equation
end

struct AddVar!
    var2idx::Dict{SymbolicT, Int}
    dvs::Set{SymbolicT}
    fullvars::Vector{SymbolicT}
    var_types::Vector{VariableType}
end

function (avc::AddVar!)(var::SymbolicT, vtype::VariableType)
    idx = get(avc.var2idx, var, nothing)
    idx === nothing || return idx::Int
    push!(avc.dvs, var)
    push!(avc.fullvars, var)
    push!(avc.var_types, vtype)
    return avc.var2idx[var] = length(avc.fullvars)
end

function add_intermediate_derivatives!(fullvars::Vector{SymbolicT}, dervaridxs::OrderedSet{Int}, addvar!::AddVar!)
    for (i, v) in enumerate(fullvars)
        @match v begin
            BSImpl.Term(; f, args) && if f isa Differential end => begin
                @assert f.order isa Int "Only integer derivative order allowed"
                order = f.order::Int
                push!(dervaridxs, i)
                inner = args[1]
                addvar!(inner, VARIABLE)
                for j in 1:(order-1)
                    addvar!(Differential(f.x, j)(inner), VARIABLE)
                end
            end
            _ => nothing
        end
    end
end

function add_intermediate_shifts!(fullvars::Vector{SymbolicT}, dervaridxs::OrderedSet{Int}, var2idx::Dict{SymbolicT, Int}, addvar!::AddVar!, iv::Union{SymbolicT, Nothing})
    lowest_shift = Dict{SymbolicT, Int}()
    for var in fullvars
        @match var begin
            BSImpl.Term(; f, args) && if f isa Shift end => begin
                steps = f.steps
                if steps > 0
                    error("Only non-positive shifts allowed. Found $var with a shift of $steps")
                end
                v = args[1]
                lowest_shift[v] = min(get(lowest_shift, v, 0), steps)
            end
            _ => nothing
        end
    end
    for var in fullvars
        lshift = typemax(Int)
        steps = typemax(Int)
        tt = iv
        v = var
        @match var begin
            BSImpl.Term(; f, args) && if f isa Shift end => begin
                steps = f.steps
                v = args[1]
                lshift = lowest_shift[v]
                tt = f.t
            end
            if haskey(lowest_shift, var) end => begin
                lshift = lowest_shift[var]
                steps = 0
                tt = iv
                v = var
            end
            _ => continue
        end
        if lshift < steps
            push!(dervaridxs, var2idx[var])
        end
        for s in (steps - 1):-1:(lshift + 1)
            sf = Shift(tt, s)
            dvar = sf(v)
            idx = addvar!(dvar, VARIABLE)
            if !(idx in dervaridxs)
                push!(dervaridxs, idx)
            end
        end
    end
end

function lower_order_var(dervar::SymbolicT, t::SymbolicT)
    @match dervar begin
        BSImpl.Term(; f, args) && if f isa Differential end => begin
            order::Int = f.order::Int
            isone(order) && return args[1]
            return Differential(f.x, order - 1)(args[1])
        end
        BSImpl.Term(; f, args) && if f isa Shift end => begin
            step = f.steps - 1
            vv = args[1]
            if step != 0
                diffvar = Shift(f.t, step)(vv)
            else
                diffvar = vv
            end
            return diffvar
        end
        _ => return Shift(t, -1)(dervar)
    end
end

function shift_discrete_system(ts::TearingState)
    # NOTE: `original_eqs` is intentionally not shifted here. This behavior is
    # necessary for hybrid system handling.
    (; fullvars, sys) = ts
    fullvars_set = Set{SymbolicT}(fullvars)
    discvars = OrderedSet{SymbolicT}()
    eqs = equations(sys)
    for eq in eqs
        SU.search_variables!(discvars, eq; is_atomic = MTKBase.OperatorIsAtomic{Union{Sample, Hold, Pre}}())
    end
    iv = MTKBase.get_iv(sys)::SymbolicT
    discmap = Dict{SymbolicT, SymbolicT}()
    for k in discvars
        k in fullvars_set || continue
        MTKBase.isoperator(k, Union{Sample, Hold, Pre}) && continue
        discmap[k] = MTKBase.simplify_shifts(Shift(iv, 1)(k))
    end

    for i in eachindex(fullvars)
        fullvars[i] = MTKBase.simplify_shifts(substitute(
            fullvars[i], discmap; filterer = Symbolics.FPSubFilterer{Union{Sample, Hold, Pre}}()))
    end
    for i in eachindex(eqs)
        eqs[i] = MTKBase.simplify_shifts(substitute(
            eqs[i], discmap; filterer = Symbolics.FPSubFilterer{Union{Sample, Hold, Pre}}()))
    end

    @set! ts.sys.eqs = eqs
    @set! ts.fullvars = fullvars
    return ts
end

"""
    $TYPEDEF

Supertype for a mutable struct representing structural information about a DAE. Must have
the following fields:

- `var_to_diff::DiffGraph`: A mapping from (indices of) variables to (the indices of) their
  derivatives.
- `eq_to_diff::DiffGraph`: A mapping from (indices of) equations to (the indices of) their
  derivatives.
- `graph::BipartiteGraph{Int, Nothing}`: The bipartite incidence graph of the system.
  Source vertices are equations, destination vertices are variables.
- `solvable_graph::Union{BipartiteGraph{Int, Nothing}, Nothing}`: Similar to `graph`, but
  instead of incidence it tracks which equations are linearly solvable for which variables.

Any additional fields are left up to the implementor.
"""
abstract type SystemStructure; end
is_only_discrete(::SystemStructure) = false

has_state_priorities(::T) where {T <: SystemStructure} = hasfield(T, :state_priorities)
get_state_priorities(ss::SystemStructure) = ss.state_priorities
has_canonical_ranks(::T) where {T <: SystemStructure} = hasfield(T, :canonical_ranks)
get_canonical_ranks(ss::SystemStructure) = ss.canonical_ranks

"""
    $TYPEDEF

Supertype for structs representing the state of a system of DAEs during structural
transformations. Must have the following fields:

- `structure<:SystemStructure`: A `SystemStructure` subtype. Should ideally be
  concretely typed to a specific implementation.
- `fullvars::AbstractVector{T}`: A list of variables in the system, ordered identically
  to the destination vertices of `structure.graph`. The `eltype` of this buffer can be
  chosen by the implementor. If this field is not present, `get_fullvars` must be
  implemented for the type.

In addition to the structural information in `structure`, this struct typically contains
information relevant to the symbolic structure of the system. This can be used to
reconstruct the system for code-generation after structural transformations.
"""
abstract type TransformationState{T} end

"""
    $TYPEDSIGNATURES

Get the ordered list of variables in the given `TransformationState`. Defaults to
`ts.fullvars`.
"""
@inline get_fullvars(ts::TransformationState) = ts.fullvars
"""
    $TYPEDSIGNATURES

Whether [`StateSelection.equations`](@ref) can be called on `ts`. Defaults to `false`.
"""
has_equations(ts::TransformationState) = false
"""
    equations(state::StateSelection.TransformationState)

Return a list of equations in the `state`, in the same order as the source vertices of
the incidence graph. This is an optional method only used for better error messages. If
this method is implemented, [`StateSelection.has_equations`](@ref) should also be made to
return `true` for this type.
"""
function equations end

"""
    $TYPEDSIGNATURES

Populate `state.structure.solvable_graph` with information about the solvability of
equations. The implementation should validate that `state.structure.solvable_graph`
is `nothing` before modifying `state`. The default implementation relies on
[`find_eq_solvables!`](@ref), to which it forwards all keyword arguments.
"""
function find_solvables!(state::TransformationState; kwargs...)
    @assert state.structure.solvable_graph === nothing
    graph = state.structure.graph
    state.structure.solvable_graph = BipartiteGraph(nsrcs(graph), ndsts(graph))
    for ieq in 1:nsrcs(graph)
        find_eq_solvables!(state, ieq; kwargs...)
    end
    return nothing
end

"""
    find_eq_solvables!(state::TransformationState, ieq::Int; kwargs...)

Identify which variables equation `ieq` can be rearranged to solve for, and populate
`state.structure.solvable_graph` accordingly. Keyword arguments are left to the
implementor, and can influence the criteria for solvability.
"""
function find_eq_solvables! end


struct SelectedState end
BipartiteGraphs.overview_label(::Type{SelectedState}) = ('∫', " Selected State", :cyan)

"""
    linear_subsys_adjmat!(state::TransformationState; kwargs...)

Find the adjacency matrix of linear subsystems in `state` and return them as a
`SparseMatrixCLIL`. May mutate `state` to cache linearity information.
"""
function linear_subsys_adjmat! end
function eq_derivative! end
function var_derivative! end

"""
    get_mm(state::TransformationState)

Return the cached integer-linear subsystem matrix (a `SparseMatrixCLIL` whose
rows are kept in sync with the structural graph, including through
`eq_derivative!`), or `nothing` when the state does not maintain one. Used by
tearing algorithms to make exact (rank-aware) decisions about integer-linear
equations.
"""
get_mm(::TransformationState) = nothing

function eq_derivative_graph!(s::SystemStructure, eq::Int)
    add_vertex!(s.graph, SRC)
    s.solvable_graph === nothing || add_vertex!(s.solvable_graph, SRC)
    # the new equation is created by differentiating `eq`
    eq_diff = add_vertex!(s.eq_to_diff)
    add_edge!(s.eq_to_diff, eq, eq_diff)
    return eq_diff
end

function var_derivative_graph!(s::SystemStructure, v::Int)
    sg = g = add_vertex!(s.graph, DST)
    var_diff = add_vertex!(s.var_to_diff)
    add_edge!(s.var_to_diff, v, var_diff)
    s.solvable_graph === nothing || (sg = add_vertex!(s.solvable_graph, DST))
    @assert sg == g == var_diff
    return var_diff
end

"""
    $TYPEDSIGNATURES

Call `BipartiteGraphs.complete` on the documented required fields of a `SystemStructure`.
This method may also be implemented manually to perform additional tasks. Should return
the completed `SystemStructure`.
"""
function complete!(s::SystemStructure)
    s.var_to_diff = complete(s.var_to_diff)
    s.eq_to_diff = complete(s.eq_to_diff)
    s.graph = complete(s.graph)
    if s.solvable_graph !== nothing
        s.solvable_graph = complete(s.solvable_graph)
    end
    s
end

isdervar(s::SystemStructure, i) = invview(s.var_to_diff)[i] !== nothing
function isalgvar(s::SystemStructure, i)
    s.var_to_diff[i] === nothing && invview(s.var_to_diff)[i] === nothing
end
function isdiffvar(s::SystemStructure, i)
    s.var_to_diff[i] !== nothing && invview(s.var_to_diff)[i] === nothing
end

function dervars_range(s::SystemStructure)
    Iterators.filter(Base.Fix1(isdervar, s), Base.OneTo(ndsts(s.graph)))
end
function diffvars_range(s::SystemStructure)
    Iterators.filter(Base.Fix1(isdiffvar, s), Base.OneTo(ndsts(s.graph)))
end
function algvars_range(s::SystemStructure)
    Iterators.filter(Base.Fix1(isalgvar, s), Base.OneTo(ndsts(s.graph)))
end

function algeqs(s::SystemStructure)
    BitSet(findall(map(1:nsrcs(s.graph)) do eq
        all(v -> !isdervar(s, v), 𝑠neighbors(s.graph, eq))
    end))
end

"""
    $TYPEDSIGNATURES

Find an equation-variable maximal bipartite matching for `s`, using the incidence graph
`s.graph`.
"""
function BipartiteGraphs.maximal_matching(s::SystemStructure; kw...)
    maximal_matching(s.graph; kw...)
end

"""
    $TYPEDSIGNATURES

Return a `Vector{Int}` mapping indices of elements in a vector of length `n_before`
to the new indices of elements in the buffer after deleting elements at indices `dels`.
Deleted elements are mapped to `0`.
"""
function get_old_to_new_idxs(n_before::Int, dels::Vector{Int})
    old_to_new = Vector{Int}(undef, n_before)
    idx = 0
    cursor = 1
    ndels = length(dels)
    for i in eachindex(old_to_new)
        if cursor <= ndels && i == dels[cursor]
            cursor += 1
            old_to_new[i] = 0
            continue
        end
        idx += 1
        old_to_new[i] = idx
    end
    n_new_eqs = idx

    return old_to_new, n_new_eqs
end

"""
    $TYPEDSIGNATURES

Remove equations in `eqs_to_rm` and variables in `vars_to_rm` from `structure`.
Return `(old_to_new_eq, old_to_new_var)::NTuple{2, Vector{Int}}` where `old_to_new_eq`
is a mapping from indices of equations in the original `structure` to their indices
in the modified `structure`. Indices mapped to zero are deleted. `old_to_new_var` is
similar, for variables.

The implementation for a custom `SystemStructure` can utilize `default_rm_eqs_vars!`
with the same signature to run the fallback method.

# Keyword arguments

- `eqs_sorted_and_uniqued`: Whether `eqs_to_rm` is consists of sorted, unique indices.
- `vars_sorted_and_uniqued`: Whether `vars_to_rm` is consists of sorted, unique indices.
"""
function rm_eqs_vars!(
        structure::SystemStructure, eqs_to_rm::Vector{Int}, vars_to_rm::Vector{Int};
        eqs_sorted_and_uniqued::Bool = false, vars_sorted_and_uniqued::Bool = false
    )
    return default_rm_eqs_vars!(
        structure, eqs_to_rm, vars_to_rm; eqs_sorted_and_uniqued, vars_sorted_and_uniqued
    )
end

function default_rm_eqs_vars!(
        structure::SystemStructure, eqs_to_rm::Vector{Int}, vars_to_rm::Vector{Int};
        eqs_sorted_and_uniqued::Bool = false, vars_sorted_and_uniqued::Bool = false
    )
    (; graph, solvable_graph, var_to_diff, eq_to_diff) = structure

    eqs_sorted_and_uniqued || unique!(sort!(eqs_to_rm))
    vars_sorted_and_uniqued || unique!(sort!(vars_to_rm))

    old_to_new_eq, n_new_eqs = get_old_to_new_idxs(nsrcs(graph), eqs_to_rm)
    old_to_new_var, n_new_vars = get_old_to_new_idxs(ndsts(graph), vars_to_rm)

    new_graph = BipartiteGraph(n_new_eqs, n_new_vars)
    if solvable_graph !== nothing
        new_solvable_graph = BipartiteGraph(n_new_eqs, n_new_vars)
    end
    new_eq_to_diff = StateSelection.DiffGraph(n_new_eqs)
    for (i, ieq) in enumerate(old_to_new_eq)
        ieq > 0 || continue
        new_nbors = map(Base.Fix1(getindex, old_to_new_var), 𝑠neighbors(graph, i))
        filter!(>(0), new_nbors)
        set_neighbors!(new_graph, ieq, new_nbors)
        if solvable_graph !== nothing
            new_nbors = map(Base.Fix1(getindex, old_to_new_var), 𝑠neighbors(solvable_graph, i))
            filter!(>(0), new_nbors)
            set_neighbors!(new_solvable_graph, ieq, new_nbors)
        end
        ediff = eq_to_diff[i]
        if ediff isa Int
            ediff = old_to_new_eq[ediff]
            @assert ediff > 0
        end
        new_eq_to_diff[ieq] = ediff
    end

    # update DiffGraph
    # NOTE: This cannot update `state_priorities` because it is called by `trivial_tearing!`,
    # and the old `trivial_tearing_postprocess!` method does that.
    new_var_to_diff = StateSelection.DiffGraph(n_new_vars)
    for (v, newv) in enumerate(old_to_new_var)
        newv > 0 || continue
        vdiff = var_to_diff[v]
        if vdiff isa Int
            vdiff = old_to_new_var[vdiff]
            vdiff > 0 || continue
        end
        new_var_to_diff[newv] = vdiff
    end
    structure.graph = new_graph
    if solvable_graph !== nothing
        structure.solvable_graph = new_solvable_graph
    end
    structure.eq_to_diff = new_eq_to_diff
    structure.var_to_diff = new_var_to_diff

    return old_to_new_eq, old_to_new_var
end

"""
This function must be implemented for any `TransformationState` with
`state::TransformationState` replacing `structure::SystemStructure` as the first argument.
It must call `rm_eqs_vars!(structure, ...)` and obtain the reindexing maps to use. It
should return the same maps.
"""
function rm_eqs_vars! end

# Tests for carpanzano_tearing.jl - determinism and Heuristic 2 correctness

using BipartiteGraphs
import Graphs: add_edge!

struct TestSystemStructure <: StateSelection.SystemStructure
    graph::BipartiteGraph{Int,Nothing}
    solvable_graph::BipartiteGraph{Int,Nothing}
    var_to_diff::DiffGraph
    eq_to_diff::DiffGraph
end

@testset "carpanzano_tearing" begin
    @testset "Heuristic 2 picks variable with maximum incidence" begin
        # Graph: 3 equations (source vertices), 3 variables (destination vertices).
        # Every edge is also present in the solvable_graph (all variables solvable in
        # all equations they appear in), so Heuristic 1 never finds a non-solvable
        # variable and falls through to Heuristic 2.
        #
        # Incidence of each variable (number of equations it appears in):
        #   v1 (idx 1): eq1, eq2        => 2
        #   v2 (idx 2): eq1, eq2, eq3   => 3   # maximum -> must be torn (algebraic)
        #   v3 (idx 3): eq1, eq3        => 2
        #
        # Before the fix, max_incidence_cnt was never updated inside the Heuristic 2
        # loop, so every variable satisfied cnt > typemin(Int) and the last variable
        # in hash-iteration order was chosen -- non-deterministic and wrong.
        graph = BipartiteGraph(3, 3)
        for (eq, var) in [(1,1),(1,2),(1,3),(2,1),(2,2),(3,2),(3,3)]
            add_edge!(graph, eq, var)
        end
        solvable_graph = BipartiteGraph(3, 3)
        for (eq, var) in [(1,1),(1,2),(1,3),(2,1),(2,2),(3,2),(3,3)]
            add_edge!(solvable_graph, eq, var)
        end

        structure = TestSystemStructure(
            graph, solvable_graph,
            DiffGraph(3), DiffGraph(3)
        )
        alg = StateSelection.CarpanzanoTearing()
        # complete() makes invview(var_eq_matching) available, which the algorithm uses
        # internally to find the variable matched to a solved equation.
        var_eq_matching = complete(
            Matching{Union{Unassigned, SelectedState}}(3), 3
        )
        active_vars = Set{Int}([1, 2, 3])
        active_eqs  = Set{Int}([1, 2, 3])

        StateSelection.carpanzano_tear_scc!(
            alg, structure, var_eq_matching, active_vars, active_eqs
        )

        # v2 has the highest incidence (3 equations) -- Heuristic 2 must choose it as
        # the algebraic (torn) variable, leaving it unmatched.
        @test var_eq_matching[2] === unassigned
        # v1 and v3 must each be matched to some equation.
        @test var_eq_matching[1] isa Int
        @test var_eq_matching[3] isa Int
    end
end

using Graphs.Experimental.Traversals
using BipartiteGraphs: set_neighbors!

function extreme_var(var_to_diff, v, level = nothing, ::Val{descend} = Val(true);
    callback = _ -> nothing) where {descend}
g = descend ? invview(var_to_diff) : var_to_diff
callback(v)
while (v′ = g[v]) !== nothing
    v::Int = v′
    callback(v)
    if level !== nothing
        descend ? (level -= 1) : (level += 1)
    end
end
level === nothing ? v : (v => level)
end

function structural_singularity_removal!(
        state::TransformationState, ::Val{ReturnPivots} = Val{false}();
        variable_underconstrained! = force_var_to_zero!, kwargs...
    ) where {ReturnPivots}
    mm = linear_subsys_adjmat!(state; kwargs...)
    if size(mm, 1) == 0
        if ReturnPivots
            return mm, PivotInfo(0, 0, Int[])
        else
            return mm # No linear subsystems
        end
    end

    (; graph, var_to_diff, solvable_graph) = state.structure
    mm, pivotinfo = structural_singularity_removal!(state, mm, Val{true}(); variable_underconstrained!)
    s = state.structure
    for (ei, e) in enumerate(mm.nzrows)
        set_neighbors!(s.graph, e, mm.row_cols[ei])
    end
    if s.solvable_graph isa BipartiteGraph{Int, Nothing}
        for (ei, e) in enumerate(mm.nzrows)
            set_neighbors!(s.solvable_graph, e, mm.row_cols[ei])
        end
    end

    if ReturnPivots
        return mm, pivotinfo
    else
        return mm
    end
end

# For debug purposes
function aag_bareiss(sys)
    state = TearingState(sys)
    complete!(state.structure)
    mm = linear_subsys_adjmat!(state)
    return aag_bareiss!(state.structure.graph, state.structure.var_to_diff, mm)
end


"""
$(SIGNATURES)

Find a variable (column) and its coefficient (value) in `M` among equations (rows) in `range`,
filtering out equations for which `mask` is `false` (`mask` can be `nothing` to avoid masking).
In case of a tie, `var_priorities` is used to choose a variable with lower priority. In case
priorities are tied, it will prefer the row with fewer elements.
"""
@inline function find_first_linear_variable(
        M::SparseMatrixCLIL,
        range,
        mask,
        var_priorities = nothing
    )
    eadj = M.row_cols
    candidate_i = 0
    candidate_v = 0
    candidate_val = 0
    candidate_nnz = 0
    @inbounds for i in range
        vertices = eadj[i]
        nnz = length(vertices)
        if !iszero(candidate_v) && var_priorities === nothing && nnz >= candidate_nnz
            continue
        end
        for (j, v) in enumerate(vertices)
            mask === nothing || mask[v] || continue
            # Prefer, in order
            # 1. Lower priority pivots
            # 2. Rows with fewer elements
            if iszero(candidate_v) || var_priorities === nothing && nnz < candidate_nnz ||
                    var_priorities !== nothing && (
                    var_priorities[v] < var_priorities[candidate_v] ||
                        var_priorities[v] == var_priorities[candidate_v] && nnz < candidate_nnz
                )
                candidate_i = i
                candidate_v = v
                candidate_val = M.row_vals[i][j]
                candidate_nnz = nnz
            end
        end
    end
    iszero(candidate_v) || return CartesianIndex(candidate_i, candidate_v), candidate_val
    return nothing
end

@inline function find_first_linear_variable(M::AbstractMatrix,
        range,
        mask,
        var_priorities = nothing)
    candidate_i = 0
    candidate_v = 0
    candidate_val = 0
    candidate_nnz = 0
    @inbounds for i in range
        row = @view M[i, :]
        nnz = count(!izero, row)
        if !izero(candidate_v) && var_priorities === nothing && nnz >= candidate_nnz
            continue
        end
        for (v, val) in enumerate(row)
            mask === nothing || mask[v] || continue
            if iszero(candidate_v) || (var_priorities === nothing && nnz < candidate_nnz || var_priorities !== nothing && (var_priorities[v] < var_priorities[candidate_v] || var_priorities[v] == var_priorities[candidate_v] && nnz < candidate_nnz))
                candidate_i = i
                candidate_v = v
                candidate_val = val
                candidate_nnz = nnz
            end
        end
    end
    return nothing
end

function find_masked_pivot(variables, M, k, var_priorities)
    return find_first_linear_variable(M, k:size(M, 1), variables, var_priorities)
end

count_nonzeros(a::AbstractArray) = count(!iszero, a)

# N.B.: Ordinarily sparse vectors allow zero stored elements.
# Here we have a guarantee that they won't, so we can make this identification
count_nonzeros(a::CLILVector) = nnz(a)

"""
    $(TYPEDSIGNATURES)

Mark variable `v` as non-linear and propagate that marking transitively to all
variables that co-appear with `v` in a linear equation.  `stack` is a
pre-allocated work buffer (cleared and reused by this function).  `var_to_lineq`
maps each variable to the set of linear equations it appears in.
"""
function mark_not_linear!(linear_variables::BitVector, stack::Vector{Int},
        var_to_lineq::Dict{Int, BitSet}, graph, v::Int)
    linear_variables[v] = false
    push!(stack, v)
    while !isempty(stack)
        v = pop!(stack)
        eqs = get(var_to_lineq, v, nothing)
        eqs === nothing && continue
        for eq in eqs, v′ in 𝑠neighbors(graph, eq)
            if linear_variables[v′]
                linear_variables[v′] = false
                push!(stack, v′)
            end
        end
    end
end

# Linear variables are highest order differentiated variables that only appear
# in linear equations with only linear variables. Also, if a variable's any
# derivatives is nonlinear, then all of them are not linear variables.
function find_linear_variables(graph, linear_equations, var_to_diff, irreducibles)
    stack = Int[]
    linear_variables = falses(length(var_to_diff))
    var_to_lineq = Dict{Int, BitSet}()
    for eq in linear_equations, v in 𝑠neighbors(graph, eq)
        linear_variables[v] = true
        vlineqs = get!(() -> BitSet(), var_to_lineq, v)
        push!(vlineqs, eq)
    end
    for v in irreducibles
        lv = extreme_var(var_to_diff, v)
        while true
            mark_not_linear!(linear_variables, stack, var_to_lineq, graph, lv)
            lv = var_to_diff[lv]
            lv === nothing && break
        end
    end

    linear_equations_set = BitSet(linear_equations)
    for (v, islinear) in enumerate(linear_variables)
        islinear || continue
        lv = extreme_var(var_to_diff, v)
        oldlv = lv
        remove = invview(var_to_diff)[v] !== nothing
        while !remove
            for eq in 𝑑neighbors(graph, lv)
                if !(eq in linear_equations_set)
                    remove = true
                end
            end
            lv = var_to_diff[lv]
            lv === nothing && break
        end
        lv = oldlv
        remove && while true
            mark_not_linear!(linear_variables, stack, var_to_lineq, graph, lv)
            lv = var_to_diff[lv]
            lv === nothing && break
        end
    end

    return linear_variables
end

"""
    $TYPEDEF

Comparator intended for use when sorting the rows of a `SparseMatrixCLIL` before
running Bareiss.
"""
struct MMSortKey{M <: SparseMatrixCLIL}
    mm::M
end

function (k::MMSortKey)(i::Integer)
    (; mm) = k
    # Sort by sparsity, earlier variable coefficient, smaller coefficient and finally by
    # equation index.
    return (length(mm.row_cols[i]), mm.row_cols[i], mm.row_vals[i], mm.nzrows[i])
end

"""
    $TYPEDSIGNATURES

Sort the rows of `mm` to obtain reproducible results from Bareiss. Uses `MMSortKey` as
the metric to sort on. The heuristic depends upon the variable ordering.
"""
function sort_mm_rows(mm::SparseMatrixCLIL{T, Ti}) where {T, Ti}
    rperm = sortperm(eachindex(mm.nzrows); by = MMSortKey(mm))
    return SparseMatrixCLIL{T, Ti}(
        mm.nparentrows, mm.ncols, mm.nzrows[rperm], mm.row_cols[rperm], mm.row_vals[rperm]
    )
end

"""
    $(TYPEDSIGNATURES)

Return `true` if variable `v` is purely algebraic, i.e. it has no derivative
and is not itself a derivative of another variable.
"""
is_algebraic(var_to_diff, v::Int)::Bool =
    var_to_diff[v] === nothing === invview(var_to_diff)[v]

function aag_bareiss!(structure, mm_orig::SparseMatrixCLIL{T, Ti}) where {T, Ti}
    (; graph, var_to_diff) = structure
    mm = copy(mm_orig)
    linear_equations_set = BitSet(mm_orig.nzrows)

    # All unassigned (not a pivot) algebraic variables that only appears in
    # linear algebraic equations can be set to 0.
    #
    # For all the other variables, we can update the original system with
    # Bareiss'ed coefficients as Gaussian elimination is nullspace preserving
    # and we are only working on linear homogeneous subsystem.

    is_linear_variables = Base.Fix1(is_algebraic, var_to_diff).(1:length(var_to_diff))
    is_highest_diff = computed_highest_diff_variables(structure)
    for i in 𝑠vertices(graph)
        # only consider linear algebraic equations
        (i in linear_equations_set &&
            all(Base.Fix1(is_algebraic, var_to_diff), 𝑠neighbors(graph, i))) &&
            continue
        for j in 𝑠neighbors(graph, i)
            is_linear_variables[j] = false
        end
    end
    solvable_variables = findall(is_linear_variables)
    sp = has_state_priorities(structure) ? get_state_priorities(structure) : nothing
    cr = has_canonical_ranks(structure) ? get_canonical_ranks(structure) : nothing
    var_priorities = if cr === nothing
        sp
    elseif sp === nothing
        cr
    else
        big = maximum(cr; init = 0) + 1
        Int[sp[i] * big + cr[i] for i in eachindex(sp)]
    end

    # `do_bareiss!` performs a *global* pivot search over the whole matrix,
    # which will happily swap rows across block boundaries when the matrix is
    # block-diagonal (e.g. several independent submodels that share no
    # variables). Such cross-block swaps don't change correctness, but they
    # perturb the within-block elimination order relative to what that block
    # would get if it were factored in isolation, which can synthesize
    # fill-in-heavy (and, downstream during tearing, near-singular) reduced
    # rows for blocks that would otherwise reduce cleanly on their own. Since
    # rows that share no column are mathematically independent linear
    # subsystems, we instead partition rows into connected components (rows
    # connected iff they share a column) and Bareiss-eliminate each component
    # separately; this is exact and immune to cross-component perturbation.
    nrows = size(mm, 1)
    parent = collect(1:nrows)
    col_to_row = Dict{Ti, Int}()
    for i in 1:nrows
        for c in mm.row_cols[i]
            j = get(col_to_row, c, 0)
            if j == 0
                col_to_row[c] = i
            else
                _uf_union!(parent, i, j)
            end
        end
    end
    components = Dict{Int, Vector{Int}}()
    for i in 1:nrows
        r = _uf_find!(parent, i)
        push!(get!(() -> Int[], components, r), i)
    end

    if length(components) <= 1
        mm = sort_mm_rows(mm)
        bar = do_bareiss!(mm, mm_orig, is_linear_variables, is_highest_diff, var_priorities)
        return mm, solvable_variables, bar
    end

    # Deterministic component order: since rows were visited in increasing
    # order above, each component's row list is already sorted, so `first`
    # gives its smallest row index.
    comp_rows = sort(collect(values(components)); by = first)

    all_nzrows = Ti[]
    all_row_cols = Vector{Vector{Ti}}()
    all_row_vals = Vector{Vector{T}}()
    tier1_pivots = Int[]
    tier2_pivots = Int[]
    tier3_pivots = Int[]
    rank1 = 0
    rank2_extra = 0
    rank3_extra = 0
    for rows in comp_rows
        sort!(rows; by = MMSortKey(mm))
        sub = SparseMatrixCLIL{T, Ti}(
            mm.nparentrows, mm.ncols, mm.nzrows[rows], mm.row_cols[rows], mm.row_vals[rows])
        (rank1_c, rank2_c, rank3_c, pivots_c) = do_bareiss!(
            sub, nothing, is_linear_variables, is_highest_diff, var_priorities)

        append!(all_nzrows, sub.nzrows)
        append!(all_row_cols, sub.row_cols)
        append!(all_row_vals, sub.row_vals)

        append!(tier1_pivots, @view pivots_c[1:rank1_c])
        append!(tier2_pivots, @view pivots_c[(rank1_c + 1):rank2_c])
        append!(tier3_pivots, @view pivots_c[(rank2_c + 1):rank3_c])
        rank1 += rank1_c
        rank2_extra += rank2_c - rank1_c
        rank3_extra += rank3_c - rank2_c
    end
    pivots_merged = vcat(tier1_pivots, tier2_pivots, tier3_pivots)
    rank2 = rank1 + rank2_extra
    rank3 = rank2 + rank3_extra

    mm = SparseMatrixCLIL{T, Ti}(mm.nparentrows, mm.ncols, all_nzrows, all_row_cols, all_row_vals)

    return mm, solvable_variables, (rank1, rank2, rank3, pivots_merged)
end

"Column-swap no-op passed to `bareiss!` when using the virtual column-swap strategy."
noop_colswap(M, i, j) = nothing

"""
    $(TYPEDEF)

A callable that swaps rows `i` and `j` in the working matrix `M` and, if
`Mold` is not `nothing`, simultaneously applies the same swap to `Mold`.
Used to keep the original matrix in sync with the Bareiss working copy during
row operations.
"""
struct SyncedSwapRows{M}
    Mold::M
end
(s::SyncedSwapRows{Nothing})(M, i::Int, j::Int) = Base.swaprows!(M, i, j)
(s::SyncedSwapRows)(M, i::Int, j::Int) = (Base.swaprows!(s.Mold, i, j); Base.swaprows!(M, i, j))

"""
    $TYPEDEF

Lazy `&&` of two boolean masks. Only implements whatever is required for `find_masked_pivot`.
"""
struct LazyMaskAnd{V1 <: AbstractVector{Bool}, V2 <: AbstractVector{Bool}}
    mask1::V1
    mask2::V2
end

Base.getindex(lma::LazyMaskAnd, i::Integer) = lma.mask1[i] && lma.mask2[i]

"""
    $(TYPEDEF)

Mutable state threaded through the Bareiss factorization callbacks.

- `rank1`/`rank2`: record where each tier of pivot selection was exhausted,
  used to compute the three rank values returned by `do_bareiss!`.
- `pivots`: accumulates the column index of every pivot chosen during elimination.
- `is_linear_variables`/`is_highest_diff`: masks used for the tiered pivot search.
"""
mutable struct BareissContext{V1 <: AbstractVector{Bool}, V2 <: AbstractVector{Bool}, P <: Union{Nothing, AbstractVector{Int}}}
    rank1::Union{Nothing, Int}
    rank2::Union{Nothing, Int}
    pivots::Vector{Int}
    is_linear_variables::V1
    is_highest_diff::V2
    valid_pivot_mask::BitVector
    var_priorities::P
end

function BareissContext(is_linear_variables, is_highest_diff, var_priorities = nothing)
    return BareissContext(
        nothing, nothing, Int[], is_linear_variables, is_highest_diff,
        trues(length(is_linear_variables)), var_priorities
    )
end

"""
    $(TYPEDSIGNATURES)

Tiered pivot selection for Bareiss factorization.  Tries three strategies in
order, recording the rank at which each tier is exhausted:
1. A pivot among `is_linear_variables` columns (rank1 boundary).
2. A pivot among `is_highest_diff` columns (rank2 boundary).
3. Any pivot in the remaining matrix.
The column index of every selected pivot is appended to `ctx.pivots`.
"""
function (ctx::BareissContext)(M, k::Int)
    if ctx.rank1 === nothing
        mask = LazyMaskAnd(ctx.is_linear_variables, ctx.valid_pivot_mask)
        r = find_masked_pivot(ctx.is_linear_variables, M, k, ctx.var_priorities)
        if r !== nothing
            push!(ctx.pivots, r[1][2])
            return r
        end
        ctx.rank1 = k - 1
    end
    if ctx.rank2 === nothing
        mask = LazyMaskAnd(ctx.is_highest_diff, ctx.valid_pivot_mask)
        r = find_masked_pivot(ctx.is_highest_diff, M, k, ctx.var_priorities)
        if r !== nothing
            push!(ctx.pivots, r[1][2])
            return r
        end
        ctx.rank2 = k - 1
    end
    # TODO: It would be better to sort the variables by
    # derivative order here to enable more elimination
    # opportunities.
    r = find_masked_pivot(nothing, M, k, ctx.var_priorities)
    r !== nothing && push!(ctx.pivots, r[1][2])
    return r
end

struct BareissContextUpdate{C <: BareissContext, F}
    context::C
    inner_update::F
end

function (bcu::BareissContextUpdate)(zero!, M, k, swapto, pivot, last_pivot; kw...)
    ctx = bcu.context
    col = swapto[2]
    ctx.valid_pivot_mask[col] = false
    return bcu.inner_update(zero!, M, k, swapto, pivot, last_pivot; kw...)
end

function do_bareiss!(M, Mold, is_linear_variables::AbstractVector{Bool},
        is_highest_diff::AbstractVector{Bool}, var_priorities = nothing)
    ctx = BareissContext(is_linear_variables, is_highest_diff, var_priorities)
    update! = BareissContextUpdate(ctx, bareiss_update_virtual_colswap_mtk!)
    bareiss_ops = (noop_colswap, SyncedSwapRows(Mold), update!, bareiss_zero!)
    rank3, = bareiss!(M, bareiss_ops; find_pivot = ctx)
    rank2 = something(ctx.rank2, rank3)
    rank1 = something(ctx.rank1, rank2)
    (rank1, rank2, rank3, ctx.pivots)
end

function force_var_to_zero!(structure::SystemStructure, ils::SparseMatrixCLIL, v::Int)
    (; graph, solvable_graph, eq_to_diff) = structure
    @set! ils.nparentrows += 1
    push!(ils.nzrows, ils.nparentrows)
    push!(ils.row_cols, [v])
    push!(ils.row_vals, [convert(eltype(ils), 1)])
    add_vertex!(graph, SRC)
    add_vertex!(solvable_graph, SRC)
    add_edge!(graph, ils.nparentrows, v)
    add_edge!(solvable_graph, ils.nparentrows, v)
    add_vertex!(eq_to_diff)
    return ils
end

"""
    $TYPEDSIGNATURES

Information about the pivots chosen by Bareiss during `structural_singularity_removal!`.
This can be returned from `structural_singularity_removal!` by passing `Val(true)` as the last
positional argument.

$TYPEDFIELDS
"""
struct PivotInfo
    """
    The length of the prefix of `pivots` that is variables which _only_ occur in linear
    equations of the sort considered by this pass. These variables must be solved for
    using the integer coefficient equations considered by this pass.
    """
    n_linear_vars::Int
    """
    Number of elements in `pivots` after `n_linear_vars` corresponding to highest order
    derivative variables.
    """
    n_highest_diff_vars::Int
    """
    The list of pivots chosen by the Bareiss algorithm.
    """
    pivots::Vector{Int}
end

"""
    $(TYPEDEF)

Tiered pivot search used for exact Bareiss factorization of pure-integer SCC
subsets during tearing. Unlike [`BareissContext`](@ref), there is no
unrestricted final tier: once `tier2` is exhausted the factorization stops.
This guarantees every chosen pivot column is an eligible (solvable-for) variable.
"""
mutable struct RestrictedBareissContext{V1 <: AbstractVector{Bool}, V2 <: AbstractVector{Bool}, P <: Union{Nothing, AbstractVector{Int}}}
    pivots::Vector{Int}
    tier1::V1
    tier2::V2
    valid_pivot_mask::BitVector
    var_priorities::P
    tier1_done::Bool
end

function RestrictedBareissContext(tier1, tier2, var_priorities = nothing)
    return RestrictedBareissContext(
        Int[], tier1, tier2, trues(length(tier1)), var_priorities, false)
end

function (ctx::RestrictedBareissContext)(M, k::Int)
    if !ctx.tier1_done
        r = find_masked_pivot(LazyMaskAnd(ctx.tier1, ctx.valid_pivot_mask), M, k, ctx.var_priorities)
        if r !== nothing
            push!(ctx.pivots, r[1][2])
            return r
        end
        ctx.tier1_done = true
    end
    r = find_masked_pivot(LazyMaskAnd(ctx.tier2, ctx.valid_pivot_mask), M, k, ctx.var_priorities)
    r === nothing && return nothing
    push!(ctx.pivots, r[1][2])
    return r
end

struct RestrictedContextUpdate{C <: RestrictedBareissContext, F}
    context::C
    inner_update::F
end

function (bcu::RestrictedContextUpdate)(zero!, M, k, swapto, pivot, last_pivot; kw...)
    bcu.context.valid_pivot_mask[swapto[2]] = false
    return bcu.inner_update(zero!, M, k, swapto, pivot, last_pivot; kw...)
end

function _uf_find!(parent::Vector{Int}, x::Int)
    while parent[x] != x
        parent[x] = parent[parent[x]]
        x = parent[x]
    end
    return x
end

function _uf_union!(parent::Vector{Int}, a::Int, b::Int)
    ra = _uf_find!(parent, a)
    rb = _uf_find!(parent, b)
    ra == rb || (parent[max(ra, rb)] = min(ra, rb))
    return nothing
end

function structural_singularity_removal!(
        state::TransformationState, ils::SparseMatrixCLIL, ::Val{ReturnPivots} = Val{false}();
        variable_underconstrained! = force_var_to_zero!
    ) where {ReturnPivots}
    (; structure) = state
    (; graph, solvable_graph, var_to_diff, eq_to_diff) = state.structure
    # Step 1: Perform Bareiss factorization on the adjacency matrix of the linear
    #         subsystem of the system we're interested in.
    #
    ils, solvable_variables, (rank1, rank2, rank3, pivots) = aag_bareiss!(structure, ils)

    ## Step 2: Simplify the system using the Bareiss factorization
    rk1vars = BitSet(@view pivots[1:rank1])
    for v in solvable_variables
        v in rk1vars && continue
        ils = variable_underconstrained!(structure, ils, v)
    end

    if ReturnPivots
        return ils, PivotInfo(rank1, rank2, pivots)
    else
        return ils
    end
end

function contract_variables(graph::BipartiteGraph, var_eq_matching::Matching,
        var_rename, eq_rename, nelim_eq, nelim_var)
    dig = DiCMOBiGraph{true}(graph, var_eq_matching)

    # Update bipartite graph
    var_deps = map(1:ndsts(graph)) do v
        [var_rename[v′]
         for v′ in neighborhood(dig, v, Inf; dir = :in) if var_rename[v′] != 0]
    end

    newgraph = BipartiteGraph(nsrcs(graph) - nelim_eq, ndsts(graph) - nelim_var)
    for e in 𝑠vertices(graph)
        ne = eq_rename[e]
        ne == 0 && continue
        for v in 𝑠neighbors(graph, e)
            newvar = var_rename[v]
            if newvar != 0
                add_edge!(newgraph, ne, newvar)
            else
                for nv in var_deps[v]
                    add_edge!(newgraph, ne, nv)
                end
            end
        end
    end

    return newgraph
end

"""
    $(TYPEDSIGNATURES)

Preemptively identify observed equations in the system and tear them. This happens before
any simplification. The equations torn by this process are ones that are already given in
an explicit form in the system and where the LHS is not present in any other equation of
the system except for other such preempitvely torn equations.

Optionally passing in the linear coefficient matrix `mm` will update it according to the
newly torn equations.
"""
function trivial_tearing!(ts::TransformationState, mm::Union{SparseMatrixCLIL, Nothing} = nothing)
    if is_only_discrete(ts.structure)
        if mm === nothing
            return ts
        else
            return ts, mm
        end
    end
    # equations that can be trivially torn an observed equations
    trivial_idxs = OrderedSet{Int}()
    # variables that have been matched to trivially torn equations
    matched_vars = OrderedSet{Int}()

    complete!(ts.structure)
    var_to_diff = ts.structure.var_to_diff
    graph = ts.structure.graph
    candidates = collect(possibly_explicit_equations(ts))
    # TODO: Use DiCMOBiGraph here and topsort the equations. It'll remove the `while true`.
    while true
        # track whether we added an equation to the trivial list this iteration
        added_equation = false
        for (i, vari) in candidates
            # don't check already torn equations
            i in trivial_idxs && continue
            if has_state_priorities(ts.structure)
                get_state_priorities(ts.structure)[vari] <= 0 || continue
            end

            # if a variable was the LHS of two trivial observed equations, we wouldn't have
            # included it in the list. Error if somehow it made it through.
            @assert !(vari in matched_vars)
            # don't tear differential/shift equations (or differentiated/shifted variables)
            var_to_diff[vari] === nothing || continue
            invview(var_to_diff)[vari] === nothing || continue
            # get the equations that the candidate matched variable is present in, except
            # those equations which have already been torn as observed
            eqidxs = setdiff(𝑑neighbors(graph, vari), trivial_idxs)
            # it should only be present in this equation
            length(eqidxs) == 1 || continue
            eqi = only(eqidxs)
            @assert eqi == i

            # for every variable present in this equation, make sure it isn't _only_
            # present in trivial equations
            isvalid = true
            for v in 𝑠neighbors(graph, eqi)
                v == vari && continue
                v in matched_vars && continue
                # `> 1` and not `0` because one entry will be this equation (`eqi`)
                isvalid &= count(!in(trivial_idxs), 𝑑neighbors(graph, v)) > 1
                isvalid &= invview(var_to_diff)[v] === nothing
                isvalid || break
            end
            isvalid || continue

            added_equation = true
            push!(trivial_idxs, eqi)
            push!(matched_vars, vari)
        end

        # if we didn't add an equation this iteration, we won't add one next iteration
        added_equation || break
    end
    torn_vars_idxs = collect(matched_vars)
    torn_eqs_idxs = collect(trivial_idxs)

    # For backward compatibility
    if hasmethod(rm_eqs_vars!, Tuple{typeof(ts), Vector{Int}, Vector{Int}})
        # `deleteat!` requires sorted indices, but we want to maintain relative order to pass
        # to `trivial_tearing_postprocess!`
        trivial_tearing_postprocess!(ts, torn_eqs_idxs, torn_vars_idxs)
        sort!(torn_eqs_idxs)
        sort!(torn_vars_idxs)
        old_to_new_eq, old_to_new_var = rm_eqs_vars!(
            ts, torn_eqs_idxs, torn_vars_idxs; eqs_sorted_and_uniqued = true,
            vars_sorted_and_uniqued = true
        )
    else
        # `deleteat!` requires sorted indices, but we want to maintain relative order to pass
        # to `trivial_tearing_postprocess!`
        sort!(torn_vars_idxs)
        sort!(torn_eqs_idxs)
        old_to_new_eq, old_to_new_var = rm_eqs_vars!(
            ts.structure, torn_eqs_idxs, torn_vars_idxs; eqs_sorted_and_uniqued = true,
            vars_sorted_and_uniqued = true
        )
        trivial_tearing_postprocess!(ts, trivial_idxs, matched_vars)
    end
    if mm !== nothing
        aliases = Dict{Int, SparseArrays.SparseVector{eltype(mm), Int}}()
        linear_eqs = Dict{Int, Int}()
        for (i, eq) in enumerate(mm.nzrows)
            linear_eqs[eq] = i
        end
        torn_vars_set = BitSet(torn_vars_idxs)
        perm = Int[]
        for (var, eq) in zip(matched_vars, trivial_idxs)
            ieq = get(linear_eqs, eq, 0)
            iszero(ieq) && continue
            # `trivial_tearing!` considers equations already written by the user in a
            # solvable form, so we know that the coefficient of `var` must be `-1` and do
            # not need to be concerned with fractions.
            eq_vars = mm.row_cols[ieq]
            eq_coeffs = mm.row_vals[ieq]

            I = Int[]
            V = Int[]
            sizehint!(I, length(eq_vars))
            sizehint!(V, length(eq_vars))
            can_be_aliased = true
            for (v, cf) in zip(eq_vars, eq_coeffs)
                if v == var
                    @assert cf == -1
                    continue
                end
                alias = get(aliases, v, nothing)
                if alias === nothing
                    # If this variable is not aliased to a linear combination,
                    # and is torn, then this equation is no longer a linear equation
                    # that can be retained in `mm`.
                    if v in torn_vars_set
                        can_be_aliased = false
                        break
                    end
                    push!(I, v)
                    push!(V, cf)
                    continue
                end
                _I, _V = SparseArrays.findnz(alias)
                append!(I, _I)
                append!(V, Iterators.map(Base.Fix1(*, cf), _V))
            end
            can_be_aliased || continue

            resize!(perm, length(I))
            sortperm!(perm, I)
            I = I[perm]
            V = V[perm]
            i = 1
            for j in Iterators.drop(eachindex(I), 1)
                if I[j] == I[i]
                    V[i] += V[j]
                else
                    i += 1
                    I[i] = I[j]
                    V[i] = V[j]
                end
            end
            
            aliases[var] = SparseArrays.SparseVector(size(mm, 2), I, V)
        end
        mm = get_new_mm(aliases, old_to_new_eq, old_to_new_var, mm)
        return ts, mm
    end

    return ts
end

"""
    $TYPEDSIGNATURES

Return an iterable of tuples. The first element of each tuple is the index of an equation
index in `state` which has a single variable (present in `get_fullvars(state)`) on the LHS.
The second element of each tuple is the index of the variable on the LHS.

These are considered candidates for [`trivial_tearing!`](@ref). Some equations may
intentionally be filtered out from this list, such as if the variable on the LHS should be
considered "irreducible" (not to be torn) or redundant equations which reduce to `0 ~ 0`.
"""
function possibly_explicit_equations(state::TransformationState)
    error("This function must be implemented to run `trivial_tearing!`")
end

"""
    $TYPEDSIGNATURES

Postprocessing function after running [`trivial_tearing!`](@ref). Update `state` given that
`torn_eqs` have been preemptively torn. The order of `torn_eqs` is important, as it
determines a topolgical ordering of the torn equations. `torn_vars` similarly identifies
the torn variables. The ordering of `torn_vars` corresponds to that of `torn_eqs`.

Prior to calling this function, the minimal required fields of `state.structure` will have
been updated appropriately (torn elements removed). At minimum, this function should update
`state` such that [`get_fullvars`](@ref) returns the appropriate subset of variables.

!!! warn
    This signature is deprecated now.
"""
function trivial_tearing_postprocess!(state::TransformationState, torn_eqs::OrderedSet{Int}, torn_vars::OrderedSet{Int})
    error("This function must be implemented to run `trivial_tearing!`")
end

"""
    $TYPEDSIGNATURES

Postprocessing function after running [`trivial_tearing!`](@ref). Update `state` given that
`torn_eqs` have been preemptively torn. The order of `torn_eqs` is important, as it
determines a topolgical ordering of the torn equations. `torn_vars` similarly identifies
the torn variables. The ordering of `torn_vars` corresponds to that of `torn_eqs`.

`torn_eqs` and `torn_vars` will be removed from `state` after this function is called.
To dispatch to this method, `rm_eqs_vars!` must be implemented for `state`.
"""
function trivial_tearing_postprocess!(state::TransformationState, torn_eqs::Vector{Int}, torn_vars::Vector{Int})
    error("This function must be implemented to run `trivial_tearing!`")
end

"""
    $TYPEDSIGNATURES

Find the equations (source vertices of `graph`) which are not matched to a variable present
in `vars_scc` according to the matching `var_eq_matching`. `varfilter` filters out
variables to exclude from this process.
"""
function free_equations(graph::BipartiteGraph, vars_scc::Vector{Vector{Int}},
                        var_eq_matching::Matching, varfilter::F) where {F}
    ne = nsrcs(graph)
    seen_eqs = falses(ne)
    for vars in vars_scc, var in vars

        varfilter(var) || continue
        ieq = var_eq_matching[var]
        if ieq isa Int
            seen_eqs[ieq] = true
        end
    end
    findall(!, seen_eqs)
end

const MatchingT{T} = Matching{T, Vector{Union{T, Int}}}
const MatchedVarT = Union{Unassigned, SelectedState}
const VarEqMatchingT = MatchingT{MatchedVarT}

"""
    $TYPEDEF

A struct containing the results of tearing.

# Fields

$TYPEDFIELDS
"""
struct TearingResult
    """
    The variable-equation matching. Differential variables are matched to `SelectedState`.
    The derivative of a differential variable is matched to the corresponding differential
    equation. Solved variables are matched to the equation they are solved from. Algebraic
    variables are matched to `unassigned`.
    """
    var_eq_matching::VarEqMatchingT
    """
    The variable-equation matching prior to tearing. This is the maximal matching used to
    compute `var_sccs` (see below). For generating the torn system, `var_eq_matching` is
    the source of truth. This should only be used to identify algebraic equations in each
    SCC.
    """
    full_var_eq_matching::VarEqMatchingT
    """
    The partitioning of variables into strongly connected components (SCCs). The SCCs are
    sorted in dependency order, so each SCC depends on variables in previous SCCs.
    """
    var_sccs::Vector{Vector{Int}}
end

"""
    $TYPEDEF

Supertype for all tearing algorithms. A tearing algorithm takes as input the
`SystemStructure` along with any other necessary arguments.

The output of a tearing algorithm must be a `TearingResult` and a `NamedTuple` of
any additional data computed in the process that may be useful for further processing.
"""
abstract type TearingAlgorithm end

module StateSelection

using DocStringExtensions
using Setfield: @set!, @set
using Graphs
import SparseArrays
import OrderedCollections: OrderedSet

# Graph Types
using BipartiteGraphs
include("graph/diff.jl")

# Math library
include("math/bareiss.jl")
include("math/sparsematrixclil.jl")
using .CLIL, .bareiss

# Downstream interferace
include("interface.jl")

# Structural transformation passes
include("singularity_removal.jl")
include("pantelides.jl")
include("tearing.jl")
include("modia_tearing.jl")
include("carpanzano_tearing.jl")
include("partial_state_selection.jl")

# Utilities
include("debug.jl")
include("utils.jl")

export DiffGraph, bareiss, CLIL, find_eq_solvables!, SelectedState
export TearingAlgorithm, TearingResult, ModiaTearing, DummyDerivativeTearing

end

struct DiffGraph <: Graphs.AbstractGraph{Int}
    primal_to_diff::Vector{Union{Int, Nothing}}
    diff_to_primal::Union{Nothing, Vector{Union{Int, Nothing}}}
end

DiffGraph(primal_to_diff::Vector{Union{Int, Nothing}}) = DiffGraph(primal_to_diff, nothing)
function DiffGraph(n::Integer, with_badj::Bool = false)
    DiffGraph(Union{Int, Nothing}[nothing for _ in 1:n],
        with_badj ? Union{Int, Nothing}[nothing for _ in 1:n] : nothing)
end

function Base.copy(dg::DiffGraph)
    DiffGraph(copy(dg.primal_to_diff),
        dg.diff_to_primal === nothing ? nothing : copy(dg.diff_to_primal))
end

@noinline function require_complete(dg::DiffGraph)
    dg.diff_to_primal === nothing &&
        error("Not complete. Run `complete` first.")
end

Graphs.is_directed(dg::DiffGraph) = true
function Graphs.edges(dg::DiffGraph)
    (i => v for (i, v) in enumerate(dg.primal_to_diff) if v !== nothing)
end
Graphs.nv(dg::DiffGraph) = length(dg.primal_to_diff)
Graphs.ne(dg::DiffGraph) = count(x -> x !== nothing, dg.primal_to_diff)
Graphs.vertices(dg::DiffGraph) = Base.OneTo(nv(dg))
function Graphs.outneighbors(dg::DiffGraph, var::Integer)
    diff = dg.primal_to_diff[var]
    return diff === nothing ? () : (diff,)
end
function Graphs.inneighbors(dg::DiffGraph, var::Integer)
    require_complete(dg)
    diff = dg.diff_to_primal[var]
    return diff === nothing ? () : (diff,)
end
function Graphs.add_vertex!(dg::DiffGraph)
    push!(dg.primal_to_diff, nothing)
    if dg.diff_to_primal !== nothing
        push!(dg.diff_to_primal, nothing)
    end
    return length(dg.primal_to_diff)
end

function Graphs.add_edge!(dg::DiffGraph, var::Integer, diff::Integer)
    dg[var] = diff
end

# Also pass through the array interface for ease of use
Base.:(==)(dg::DiffGraph, v::AbstractVector) = dg.primal_to_diff == v
Base.:(==)(dg::AbstractVector, v::DiffGraph) = v == dg.primal_to_diff
Base.eltype(::DiffGraph) = Union{Int, Nothing}
Base.size(dg::DiffGraph) = size(dg.primal_to_diff)
Base.length(dg::DiffGraph) = length(dg.primal_to_diff)
Base.getindex(dg::DiffGraph, var::Integer) = dg.primal_to_diff[var]
Base.getindex(dg::DiffGraph, a::AbstractArray) = [dg[x] for x in a]

function Base.setindex!(dg::DiffGraph, val::Union{Integer, Nothing}, var::Integer)
    if dg.diff_to_primal !== nothing
        old_pd = dg.primal_to_diff[var]
        if old_pd !== nothing
            dg.diff_to_primal[old_pd] = nothing
        end
        if val !== nothing
            #old_dp = dg.diff_to_primal[val]
            #old_dp === nothing || error("Variable already assigned.")
            dg.diff_to_primal[val] = var
        end
    end
    return dg.primal_to_diff[var] = val
end
Base.iterate(dg::DiffGraph, state...) = iterate(dg.primal_to_diff, state...)

function BipartiteGraphs.complete(dg::DiffGraph)
    dg.diff_to_primal !== nothing && return dg
    diff_to_primal = Union{Int, Nothing}[nothing for _ in 1:length(dg.primal_to_diff)]
    for (var, diff) in edges(dg)
        diff_to_primal[diff] = var
    end
    return DiffGraph(dg.primal_to_diff, diff_to_primal)
end

function BipartiteGraphs.invview(dg::DiffGraph)
    require_complete(dg)
    return DiffGraph(dg.diff_to_primal, dg.primal_to_diff)
end

struct DiffChainIterator{Descend}
    var_to_diff::DiffGraph
    v::Int
end

function Base.iterate(di::DiffChainIterator{Descend}, v = nothing) where {Descend}
    if v === nothing
        vv = di.v
        return (vv, vv)
    end
    g = Descend ? invview(di.var_to_diff) : di.var_to_diff
    v′ = g[v]
    v′ === nothing ? nothing : (v′, v′)
end
